import "cleave.js/dist/addons/cleave-phone.i18n";
import { DomSanitizer } from '@angular/platform-browser';
import { Camera } from "@ionic-native/camera/ngx";
import { ImagePicker } from "@ionic-native/image-picker/ngx";
import { WebView } from "@ionic-native/ionic-webview/ngx";
export declare class VhSalesWebAPPEndUser {
    private vhAlgorithm;
    private webappserverURL;
    private project;
    private dbstorage;
    private database;
    private store;
    private user;
    private singedin;
    private branchs;
    constructor(vhAlgorithm: VhAlgorithm);
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.initializeProject('vhsales','firebase','research','research', 394637, '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2')
          .then(()=>{
            //-----------your code----------
          })
     * @param project
     * @param dbstorage
     * @param dbserverversion
     * @param camserverversion
     * @param fwcode
     * @param database : một database nào đó '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2'
     * @returns
     */
    initializeProject(project: string, dbstorage: string, dbserverversion: string, camserverversion: string, fwcode: number, database: string): Promise<any>;
    getStore(): any;
    getUser(): any;
    /**
       * Hàm này tạo bill_code theo số thứ tự (trong ngày) của từng loại bill_type
       * @example:
       * this.vhSalesWebAPPEndUser.createBillCode(new Date(), 7)
            .then((bill_code)=>{
              console.log('createBillCode', bill_code);
            })
       *  @param billdate
       *  @param bill_type
       */
    createBillCode(billdate: any, bill_type: number): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPEndUser.addComponentContent('webapp_abouts', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addComponentContent(colname: string, data: object): Promise<unknown>;
    /**
     * Hàm này dùng đối với các component chỉ có 1 record dữ liệu duy nhất như component giới thiếu, componet liên lạc....
     * @example
     * this.vhSalesWebAPPEndUser.setComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param id_componentcontent : lấy theo tên của component
      * @param data : tất cả các trường của doc/recort
      * @return  Promise object => response = {vcode, message}
      */
    setComponentContent(colname: string, id_componentcontent: string, data: object): Promise<unknown>;
    /**
 * @example
 * this.vhSalesWebAPPEndUser.updateComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
  * @param colname
  * @param id_componentcontent
  * @param value
  * @return  Promise object => response = {vcode, message}
  */
    updateComponentContent(colname: string, id_componentcontent: string, value: object): Promise<unknown>;
    /**
   * @example
   * this.vhSalesWebAPPEndUser.deleteComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message}
    */
    deleteComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
   * @example
   * this.vhSalesWebAPPEndUser.getComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getComponentContentsByFields('webapp_abouts', {name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getComponentContentsByFields(colname: string, query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPEndUser.getComponentContents('webapp_abouts')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    getComponentContents(colname: string): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPEndUser.searchList('products',["name", "describe"], 'Điện Thoại', 20, 1)
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let array_searched_data = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param array_field
      * @param value
      * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
      * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
      * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
      */
    searchList(colname: string, array_field: any, value: string, limit: number, page: number): Promise<unknown>;
    /**
       * @example:
       * this.vhSalesWebAPPEndUser.forgotPassword_byEmail('salesf110@gmail.com','h674567')
             .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code 0-----------
                    let user = response.data;
                }else if(response.vcode === 1){
                    //-----------your code 1-----------
                }
             },error=>{
                console.log('error', error)
             })
       * @param email
       * @param password
       * @return Promise object => response = {vcode, message}
       * vcode == 0: Message sent to email address successfully
       * vcode == 1: Email address does not exist
       */
    forgotPassword_byEmail(email: string, password: string): Promise<any>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.changePassword_byEmail('salesf110@gmail.com','h674567', 'V12345678')
           .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code 0-----------
                  let user = response.data;
              }else if(response.vcode === 1){
                  //-----------your code 1-----------
              }else if(response.vcode === 2){
                  //-----------your code 2-----------
              }else if(response.vcode === 3){
                  //-----------your code 3-----------
              }
           },error=>{
              console.log('error', error)
           })
     * @param email
     * @param oldpassword
     * @param newpassword
     * @return Promise object => response = {vcode, message}
     * vcode == 0: Message sent to email address successfully
     * vcode == 1: Email address does not exist
     * vcode == 2: wrong oldpassword
     * vcode == 3: please reset your password
     */
    changePassword_byEmail(email: string, oldpassword: string, newpassword: string): Promise<any>;
    /**
       * @example:
       * this.vhSalesWebAPPEndUser.signup_byEmail('salesf110@gmail.com','h674567',{})
             .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code 1-----------
                    let enduser = response.data;
                }else if(response.vcode === 1){
                    //-----------your code 2-----------
                }
             },error=>{
                console.log('error', error)
             })
       * @param email
       * @param password
       * @param info : thông tin của enduser
       * @return Promise object => response = {vcode, message, data}
       * vcode == 0: User account registered successful
       * vcode == 1: User Email already exists
       * @notice : sau khi đăng ký thành công, người dùng phải vào email xác nhận xác nhận việc đăng ký này
       */
    signup_byEmail(email: string, password: string, info: object): Promise<any>;
    /**
       * @example:
       * this.vhSalesWebAPPEndUser.signin_byEmail('salesf110@gmail.com','h674567')
             .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code 0-----------
                    let user = response.data;
                }else if(response.vcode === 1){
                    //-----------your code 1-----------
                }else if(response.vcode === 2){
                    //-----------your code 2-----------
                }else if(response.vcode === 3){
                    //-----------your code 3-----------
                }else if(response.vcode === 4){
                    //-----------your code 4-----------
                }
             },error=>{
                console.log('error', error)
             })
       * @param email
       * @param password
       * @return Promise object => response = {vcode, message, data}
       * vcode == 0: Signed in successfully
       * vcode == 1: Wrong email
       * vcode == 2: Please login into your email to confirm your account on my website or APP
       * vcode == 3: Please reset your password
       * vcode == 4: Wrong password
       */
    signin_byEmail(email: string, password: string): Promise<any>;
    /**
     * Hàm này cập nhật thông tin người dùng webapp (người dùng đã nhập vào webapp mới cập  nhật được)
     * @example:
     * this.vhSalesWebAPPEndUser.updateUser('5fb6780ca2148e09806c5b01', {name:'Nguyễn Văn A'})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param value : object
      * @return  Promise object => response = {vcode, message)}
      */
    updateUser(value: object): Promise<unknown>;
    /**
   * Hàm này xóa email người dùng webapp (người dùng đã nhập vào webapp mới xóa được)
   * @example:
   * this.vhSalesWebAPPEndUser.deleteUser()
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                //thoat ra trang chưa  đăng nhập
            }
          },error=>{
              console.log('error', error)
          })
    * @return  Promise object => response = {vcode, message)}
    * vcode == 0: Deleted successfully
    */
    deleteUser(): Promise<unknown>;
    /**
   * @example:
   * this.vhSalesWebAPPEndUser.onAuthStateChanged()
         .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code 0-----------
                let user = response.data;
            }else if(response.vcode === 1){
                //-----------your code 1-----------
            }else if(response.vcode === 2){
                //-----------your code 2-----------
            }else if(response.vcode === 3){
                //-----------your code 3-----------
            }else if(response.vcode === 4){
                //-----------your code 4-----------
            }
         },error=>{
            console.log('error', error)
         })
   * @return Promise object => response = {vcode, message}
   * vcode == 0: Signed in successfully
   * vcode == 1: wrong access_token->email
   * vcode == 2: wrong access_token->password
   * vcode == 3: Please login into your email to confirm your account on my website or APP
   * vcode == 4: Please reset your password
   */
    onAuthStateChanged(): Promise<any>;
    /**
    * @example
    * this.vhSalesWebAPPEndUser.signout();
    * @return void
    */
    signout(): void;
    /**
     * @example
     * let bool = this.vhSalesWebAPPEndUser.checkSignin();
     * @return Boolean => true or false
     */
    checkSignin(): any;
    /**
     * @example
     * this.vhSalesWebAPPEndUser.getProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getProduct(id_product: any): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPEndUser.getNewProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    private getNewProduct;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getNewProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    private getNewProductsByFields;
    /**
   * @example
   * let id_sub_or_product = id_subproduct?id_subproduct:id_product;
   * this.vhSalesWebAPPEndUser.getDetailProduct(id_sub_or_product)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_sub_or_product
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getDetailProduct(id_sub_or_product: any): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getDetailProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getDetailProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPEndUser.getCategory('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let category = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_category
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getCategory(id_category: any): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getCategorysByFields({name:{$eq:'name abc'}}, {},{},6, 1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let categorys = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getCategorysByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPEndUser.getBranch('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.data.vcode === 0){
                    //-----------your code-----------
                    let branch = response.data.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_branch
      * @return  Promise object => obj = {vcode, message, data(object)}
      */
    private getBranch;
    /**
     * @example
     * this.vhSalesWebAPPEndUser.getBranchs(')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let branchs = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    private getBranchs;
    /**
     * @example:
     * let branch = this.vhSalesWebAPPEndUser.getlocalBranch('5fb6780ca2148e09806c5b01');
     * @param id_branch
     * @return Object => obj = {} or null
     */
    getlocalBranch(id_branch: any): any;
    /**
     * @example:
     * let branchs = this.vhSalesWebAPPEndUser.getlocalBranchs();
     * @return Array(object) => array = [{},{},...]
     */
    getlocalBranchs(): any[];
    /**
     * Khi giao diện người dùng (user) khởi động xong và vào trang chủ xong thì dùng hàm getDefaultBranch() lấy chi nhánh mặc định về (lưu ở local), sẽ có 2 trường hợp xảy ra:
     * + Trường hợp lấy về khác null thì kiểm tra chi nhánh này có tồn tại ở database không (dùng hàm getlocalBranch()). Nếu tồn tại thì
     * không có vấn đề gì xảy ra. Nếu không tồn tại thì hiển thị popup có các chi nhánh lên để khách chọn và lưu vô local
     * (dùng hàm setDefaultBranch()), lưu ý nếu có 1 chi nhánh thôi thì setDefaultBranch luôn, khỏi phải hiện popup ra làm chi
     * + Trường họp lấy về bằng null hiển thị popup có các chi nhánh lên để khách chọn và lưu vô local (dùng hàm setDefaultBranch()),
     * lưu ý nếu có 1 chi nhánh thôi thì setDefaultBranch luôn, khỏi phải hiện popup ra làm chi
     * @example:
     * this.vhSalesWebAPPEndUser.setDefaultBranch('Stbaw79rRVVIm2US55kh');
     * @param branch : lấy branch này y chang từ getlocalBranchs() và truyền vào hàm
     * @returns void
     */
    setDefaultBranch(id_branch: object): void;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getDefaultBranch();
     * @returns object or null
     */
    getDefaultBranch(): any;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getDefaultBranch();
     * @returns void
     */
    clearDefaultBranch(): void;
    /**
     * Hàm này trả về thông tin hạng của khách hàng (sau khi đã đăng nhập)
       * @example:
       * this.vhSalesWebAPPEndUser.getCustomerClass()
            .then((response:any)=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  if(response.data){
                    let customer_class = response.data;
                  }else{
                    //Khách hàng này chưa có hạng (nhờ chủ cửa hàng phân hạng cho họ)
                  }
              }
            },error=>{
                console.log('error', error)
            })
        * @return Promise => payment ={vcode, message, data(object or null)} / error
        * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
        * vcode == 0: success
        * vcode == 11: not logged in
        */
    getCustomerClass(): Promise<unknown>;
    /**
     * Hàm này lấy về một mã coupon tương ứng với 1 đợt phát hành (đang cho phép phát hành)
     * Khách hàng của các cửa hàng khi vào web hoặc app của cửa hàng sẽ thấy được các đợt phát hành coupon (đang cho phép phát hành),
     * tương ứng với mỗi đợt phát hành này web/app sẽ sinh ra một mã coupon mới gọi là mã coupon chưa phát hành (nó chỉ mới sinh ra ở web/app thôi chưa có trên database),
     * khi nào khách hàng đổi điểm để lấy mã coupon này thì trên database mới phát hành và đổi điểm của khách luôn (nghĩa là trên database, mã coupon này ko có ở status_1 mà khi đổi điểm tạo thẳng status_3 luôn)
     * @example:
     * this.vhSalesWebAPPEndUser.getCouponCodes_Not_Release()
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let coupon_codes = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @return  Promise object => obj = {vcode, message, data(array)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    getCouponCodes_Not_Release(): Promise<unknown>;
    /**
     * Hàm này lấy về tất cả các mã coupon mà khách hàng đang sở hữu, đó là mã coupon đã đổi điểm (status_3) và mã coupon đã dùng để thanh toán (status_4)
    * @example:
    * this.vhSalesWebAPPEndUser.getCouponCodes_Owned()
           .then(response:any)=>{
             console.log('response', response);
             if(response.vcode === 0){
                 //-----------your code-----------
                 let coupon_codes = response.data;
             }
           },error=>{
               console.log('error', error)
           })
   * @return  Promise object => obj = {vcode, message, data(array)}
   * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
   */
    getCouponCodes_Owned(): Promise<unknown>;
    /**
   * hàm này để đổi phiếu từ điểm của khách hàng. Đổi thành công tự động tạo lịch sử đổi điểm của khách hàng
   * hàm này đã tạo mới mã coupon với status_3 (trường hợp này ko tồn tại status_1)
   * hàm này đã cập nhật lại trường earned_points, id_customer, branch_earned_points cho khách hàng
   * @example:
   * let array = [{id_coupon_code, points, value},{}...]
   * this.vhSalesWebAPPEndUser.exchangeCouponCode_byEarningPoints(coupon_code_not_release)
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let coupon_codes = response.data;
            }
          },error=>{
              console.log('error', error)
          })
    * @param coupon_code_not_release : {code, date_expire, date_validity, id_branch, id_coupon, id_coupon_release_detail, name_coupon, name_coupon_release, points, value} (lấy nguyên coupon_code_not_release đã có sẳn)
    * @return  Promise object => obj = {vcode, message, data(coupon_code)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    exchangeCouponCode_byEarningPoints(coupon_code_not_release: any): Promise<unknown>;
    /**
    * Hàm này dùng cập nhật lại các trường của mã coupon.
    * Lưu ý trường status_9 là trạng thái mã coupon thanh toán cho đơn đặt hàng bill_type 36,
    * sau khi đơn đặt hàng chuyển sang đơn mua hàng bill_type 1 thì status sẽ chuyển sang 4
    * @example:
    * let value ={status:9, id_bill: "5fb67fda87c0f21d484cbdf3", date_use_ordered: new Date(), id_customer_used: 'SNYgA1NE0ZqtFdwVkTMz'}
    * this.vhSalesWebAPPEndUser.updateCouponCode('YrgePVXyz3VDEFMKG2xA', value)
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
              let customer_class = response.data;
          }
        },error=>{
            console.log('error', error)
        })
    * @param id_coupon_code : id của mã coupon
    * @param value : {status, id_bill, date_used, id_customer_used}
    * @return Promise => payment ={vcode, message, data(undefined)} / error
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    updateCouponCode(id_coupon_code: string, value: object): Promise<unknown>;
    /**
     * Hàm này lấy về một mã voucher tương ứng với 1 đợt phát hành (đang cho phép phát hành)
     * Khách hàng của các cửa hàng khi vào web hoặc app của cửa hàng sẽ thấy được các đợt phát hành voucher (đang cho phép phát hành),
     * tương ứng với mỗi đợt phát hành này web/app sẽ sinh ra một mã voucher mới gọi là mã voucher chưa phát hành (nó chỉ mới sinh ra ở web/app thôi chưa có trên database),
     * khi nào khách hàng đổi điểm để lấy mã voucher này thì trên database mới phát hành và đổi điểm của khách luôn (nghĩa là trên database, mã voucher này ko có ở status_1 mà khi đổi điểm tạo thẳng status_3 luôn)
     * @example:
     * this.vhSalesWebAPPEndUser.getVoucherCodes_Not_Release()
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let voucher_codes = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @return  Promise object => obj = {vcode, message, data(array)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    getVoucherCodes_Not_Release(): Promise<unknown>;
    /**
     * Hàm này lấy về tất cả các mã voucher mà khách hàng đang sở hữu, đó là mã voucher đã đổi điểm (status_3) và mã voucher đã dùng để thanh toán (status_4)
    * @example:
    * this.vhSalesWebAPPEndUser.getVoucherCodes_Owned()
           .then(response:any)=>{
             console.log('response', response);
             if(response.vcode === 0){
                 //-----------your code-----------
                 let voucher_codes = response.data;
             }
           },error=>{
               console.log('error', error)
           })
   * @return  Promise object => obj = {vcode, message, data(array)}
   * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
   */
    getVoucherCodes_Owned(): Promise<unknown>;
    /**
  * hàm này để đổi mã voucher từ điểm của khách hàng. Đổi thành công tự động tạo lịch sử đổi điểm của khách hàng
  * hàm này đã tạo mới mã voucher với status_3 (trường hợp này ko tồn tại status_1)
  * hàm này đã cập nhật lại trường earned_points, id_customer, branch_earned_points cho khách hàng
  * @example:
  * this.vhSalesWebAPPEndUser.exchangeVoucherCode_byEarningPoints(voucher_code_not_release)
         .then((response:any)=>{
           console.log('response', response);
           if(response.vcode === 0){
               //-----------your code-----------
               let voucher_codes = response.data;
           }
         },error=>{
             console.log('error', error)
         })
   * @param voucher_code_not_release : {code, date_expire, date_validity, id_branch, id_voucher, id_voucher_release_detail, name_voucher, name_voucher_release, points, value} (lấy nguyên voucher_code_not_release đã có sẳn ở hàm getVoucherCodes_Not_Release())
   * @return  Promise object => obj = {vcode, message, data(voucher_code)}
   * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
   */
    exchangeVoucherCode_byEarningPoints(voucher_code_not_release: any): Promise<unknown>;
    /**
     * hàm này để chọn 1 voucher_code thuộc chương trình bán hàng đưa vào giỏ hàng, sau đó khách sẽ tiến hành đặt mua
     * hàm này đã tạo mới mã voucher với status_6 (trường hợp này ko tồn tại status_1)
     * @example:
     * this.vhSalesWebAPPEndUser.createVoucherCode_6(voucher_code_not_release)
            .then((response:any)=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let voucher_codes = response.data;
              }
            },error=>{
                console.log('error', error)
            })
      * @param voucher_code_not_release : {code, date_expire, date_validity, id_branch, id_voucher, id_voucher_release_detail, name_voucher, name_voucher_release, points, value} (lấy nguyên voucher_code_not_release đã có sẳn ở hàm getVoucherCodes_Not_Release())
      * @return  Promise object => obj = {vcode, message, data(voucher_code)}
      * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
      */
    createVoucherCode_6(voucher_code_not_release: any): Promise<unknown>;
    /**
     * Hàm này bỏ chọn 1 mã voucher_code mà khách đã được chọn để mua trước đó (status_6)
     * @example:
     * this.vhSalesWebAPPEndUser.deleteVoucherCode_6('5fb67fda87c0f21d484cbdf3')
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
      * @param id_voucher_code
      * @return Promise => response.data = undefined / error
      */
    deleteVoucherCode_6(id_voucher_code: string): Promise<unknown>;
    /**
     * Hàm này chọn 1 voucher_code có status 2 hoặc 3 chuyển sang status 8 (trạng thái "chọn đổi voucher hàng hóa")
     * @example:
     * this.vhSalesWebAPPEndUser.changeVoucherCode_2or3_to8('5fb67fda87c0f21d484cbdf3')
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
      * @param id_voucher_code
      * @return Promise => response.data = undefined / error
      */
    changeVoucherCode_2or3_to8(id_voucher_code: string): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getVoucherCodes_byFields({status:{$in:[2,3]}}, {},{},0)
            .then((response:any)=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let bills = response.data;
              }
            },error=>{
                console.log('error', error)
            })
      * @param query
      * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
      * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
      * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
      * @return  Promise object => obj = {vcode, message, data(array)}
      */
    getVoucherCodes_byFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    /**
    * Hàm này dùng cập nhật lại các trường của mã voucher.
    * @example:
    * let value ={status:9, id_bill: "5fb67fda87c0f21d484cbdf3", date_use_ordered: new Date(), id_customer_used: 'SNYgA1NE0ZqtFdwVkTMz'}
    * this.vhSalesWebAPPEndUser.updateVoucherCode('YrgePVXyz3VDEFMKG2xA', value)
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
              let customer_class = response.data;
          }
        },error=>{
            console.log('error', error)
        })
    * @param id_voucher_code : id của mã voucher
    * @param value : {status, id_bill, date_used, id_customer_used}
    * @return Promise => payment ={vcode, message, data(undefined)} / error
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    updateVoucherCode(id_voucher_code: string, value: object): Promise<unknown>;
    /**
     * Hàm này lấy về một mã payment_card tương ứng với 1 đợt phát hành (đang cho phép phát hành)
     * Khách hàng của các cửa hàng khi vào web hoặc app của cửa hàng sẽ thấy được các đợt phát hành payment_card (đang cho phép phát hành),
     * tương ứng với mỗi đợt phát hành này web/app sẽ sinh ra một mã payment_card mới gọi là mã payment_card chưa phát hành (nó chỉ mới sinh ra ở web/app thôi chưa có trên database),
     * khi nào khách hàng đổi điểm để lấy mã payment_card này thì trên database mới phát hành và đổi điểm của khách luôn (nghĩa là trên database, mã payment_card này ko có ở status_1 mà khi đổi điểm tạo thẳng status_3 luôn)
     * @example:
     * this.vhSalesWebAPPEndUser.getPaymentCardCodes_Not_Release()
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let payment_card_codes = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @return  Promise object => obj = {vcode, message, data(array)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    getPaymentCardCodes_Not_Release(): Promise<unknown>;
    /**
    * Hàm này lấy về tất cả các mã payment_card mà khách hàng đang sở hữu, đó là mã payment_card đã đổi điểm (status_3) và mã payment_card đã dùng để thanh toán (status_4)
    * @example:
    * this.vhSalesWebAPPEndUser.getPaymentCardCodes_Owned()
          .then(response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let payment_card_codes = response.data;
            }
          },error=>{
              console.log('error', error)
          })
  * @return  Promise object => obj = {vcode, message, data(array)}
  * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
  */
    getPaymentCardCodes_Owned(): Promise<unknown>;
    /**
  * hàm này để đổi mã payment_card từ điểm của khách hàng. Đổi thành công tự động tạo lịch sử đổi điểm của khách hàng
  * hàm này đã tạo mới mã payment_card với status_3 (trường hợp này ko tồn tại status_1)
  * hàm này đã cập nhật lại trường earned_points, id_customer, branch_earned_points cho khách hàng
  * @example:
  * let array = [{id_payment_card_code, points, value},{}...]
  * this.vhSalesWebAPPEndUser.exchangePaymentCardCode_byEarningPoints(payment_card_code_not_release)
         .then((response:any)=>{
           console.log('response', response);
           if(response.vcode === 0){
               //-----------your code-----------
               let payment_card_codes = response.data;
           }
         },error=>{
             console.log('error', error)
         })
   * @param payment_card_code_not_release : {code, date_expire, date_validity, id_branch, id_payment_card, id_payment_card_release_detail, name_payment_card, name_payment_card_release, points, value} (lấy nguyên payment_card_code_not_release đã có sẳn)
   * @return  Promise object => obj = {vcode, message, data(payment_card_code)}
   * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
   */
    exchangePaymentCardCode_byEarningPoints(payment_card_code_not_release: any): Promise<unknown>;
    /**
   * hàm này để chọn 1 mã payment_card_code thuộc chương trình bán hàng đưa vào giỏ hàng, sau đó khách sẽ tiến hành đặt mua
   * hàm này đã tạo mới mã payment_card_code với status_6 (trường hợp này ko tồn tại status_1)
   * @example:
   * this.vhSalesWebAPPEndUser.createPaymentCardCode_6(payment_card_code_not_release)
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let payment_card_code = response.data;
            }
          },error=>{
              console.log('error', error)
          })
    * @param payment_card_code_not_release : {code, date_expire, date_validity, id_branch, id_payment_card, id_payment_card_release_detail, name_payment_card, name_payment_card_release, points, value} (lấy nguyên payment_card_code_not_release đã có sẳn ở hàm getPaymentCardCodes_Not_Release())
    * @return  Promise object => obj = {vcode, message, data(payment_card_code)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    createPaymentCardCode_6(payment_card_code_not_release: any): Promise<unknown>;
    /**
     * Hàm này bỏ chọn 1 mã payment_card_code mà khách đã chọn để mua trước đó (status_6)
     * @example:
     * this.vhSalesWebAPPEndUser.deletePaymentCardCode_6('5fb67fda87c0f21d484cbdf3')
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
      * @param id_payment_card_code
      * @return Promise => response.data = undefined / error
      */
    deletePaymentCardCode_6(id_payment_card_code: string): Promise<unknown>;
    /**
   * Hàm này chọn 1 payment_card_code có status 2 hoặc 3 chuyển sang status 8 (trạng thái "chọn đổi thẻ lấy hàng hóa")
   * @example:
   * this.vhSalesWebAPPEndUser.changePaymentCardCode_2or3_to8('5fb67fda87c0f21d484cbdf3')
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
          }
        },error=>{
            console.log('error', error)
        })
    * @param id_payment_card_code
    * @return Promise => response.data = undefined / error
    */
    changePaymentCardCode_2or3_to8(id_payment_card_code: string): Promise<unknown>;
    /**
   * @example:
   * this.vhSalesWebAPPEndUser.getPaymentCardCodes_byFields({status:{$in:[2,3]}}, {},{},0)
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bills = response.data;
            }
          },error=>{
              console.log('error', error)
          })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @return  Promise object => obj = {vcode, message, data(array)}
    */
    getPaymentCardCodes_byFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    updatePaymentCardCode(id_payment_card_code: string, value: object): Promise<unknown>;
    /**
     * @example://xem các trường trong ví dụ này thiếu nói anh huy bổ sung
        let data = {
          id_branch: 'sdfaoeuow984439v4n949',
          id_customer: 'gu86gd3th6pfgw54adthji7',
          date: new Date(),
          bill_type:35,     //bill tạm được enduser tạo từ kênh online qua Web, APP
          payment: 990.000,
          tax: 0,
          total: 990.000
        }
        this.vhSalesWebAPPEndUser.createBill(data)
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let bill = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
        bill = {
              _id,              //hệ thống tự thêm vào
              bill_code,        //hệ thống tự thêm vào
  
              id_branch,
              id_customer,
              date,
              bill_type,
              payment,
              tax,
              total
        }
      * @param data : object
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    private createBill;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.updatePayment('5fb6780ca2148e09806c5b01', {total:990000})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param id_bill
      * @param value : object
      * @return  Promise object => response = {vcode, message)}
      */
    updateBill(id_bill: string, value: object): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.deleteBill('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
      * @param id_bill
      * @return Promise => response.data = undefined / error
      */
    deleteBill(id_bill: any): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getBillsByFields({name:{$eq:'name abc'}}, {},{},0)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let bills = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @return  Promise object => obj = {vcode, message, data(array)}
    */
    getBillsByFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getBill('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill = response.data;
            }
          },error=>{
              console.log('error', error)
          })
     *  @param id_bill
     *  @return Promise => payment ={vcode, message, data(object or null)} / error
     */
    getBill(id_bill: any): Promise<unknown>;
    /**
     * Hàm này dùng khi khách hàng đưa sản phảm vào giỏ hàng (bill_type = 35)
     * @example:
      let data = {
        id_branch: '5gt436urbdfsky6',
        id_customer: 'gu86gd3th6pfgw54',
        tax: 0,
        price: 99000,
        quantity: 1,
      }
      this.vhSalesWebAPPEndUser.createBill_Detail_35(data)
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_detail = response.data;
            }
          },error=>{
              console.log('error', error)
          })
      bill_detail = {
          _id,                //hệ thống tự thêm vào
          date: new Date(),   //hệ thống tự thêm vào
          bill_type: 35,      //hệ thống tự thêm vào, bill tạm được enduser tạo từ kênh online qua Web, APP
  
          id_branch,
          id_customer,
          tax,
          price,
          quantity
      }
      * @param data : object
      * @return  Promise object => obj = {vcode, message, data(object)}
      * Luu ý: chỉ có 2 trường hợp, hoặc là thêm thành công, hoặc là báo lỗi error
      */
    createBill_Detail_35(data: any): Promise<unknown>;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt hàng (bill_type = 36)
      * Lưu ý: trường webapp_payment_payment_chose true/false của sản phẩm, quy định sản phẩm được chọn hoặc chưa chọn để thanh toán
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        tax: 0,
        fee: 0,
        total: 10000000,
      }
      let bill_details =[{
        id_product: 'pro006',
        price: 10000000,
        quantity: 1
      },{
        id_product: 'pro007',
        price: 12000000,
        quantity: 1
      }]
      this.vhSalesWebAPPEndUser.createBill_Billdetail_36(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
     * @param bill
     * @param bill_details
     * @return Promise => object = {} or null
     */
    createBill_Billdetail_36(bill: any, bill_details: any): any;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt mua voucher (bill_type = 42)
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        date: new Date(),
        tax: 0,
        fee: 0,
        total: 200000,
      }
      let bill_details =[{
        id_voucher: "pEvqDLsBEFaAROUbyqZV",
        id_voucher_code: "njoaSkUIxkGVxBUyHN10",
        price: 200000,
        quantity: 1,
        ratio: 1,
        vtype: 1,
        products:[{
          id_product: "xmVt5uDH8jaajYJ1KmVo",
          price: 0, //vì bán voucher nên giá sản phẩm luôn luôn là 0
          ptype: 1,
          quantity: 2,
          ratio: 1
        },{
          id_product: "PGtdEroQNKSJjhj1okPs",
          price: 0,
          ptype: 1,
          quantity: 2,
          ratio: 1
        }]
      this.vhSalesWebAPPEndUser.createBill_Billdetail_42(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
     * @param bill
     * @param bill_details
     * @return Promise => object = {} or null
     */
    createBill_Billdetail_42(bill: any, bill_details: any): any;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt đổi voucher lấy sản phẩm (bill_type = 43)
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        date: new Date(),
        tax: 0,
        fee: 0,
        total: 0,
      }
      let bill_details =[{
        id_voucher: "pEvqDLsBEFaAROUbyqZV",
        id_voucher_code: "njoaSkUIxkGVxBUyHN10",
        vtype: 1,
        products:[{
          id_product: "xmVt5uDH8jaajYJ1KmVo",
          price: 0, //vì đổi voucher lấy hàng, nên price luôn luôn là 0
          ptype: 1,
          quantity: 2,
          ratio: 1
        },{
          id_product: "PGtdEroQNKSJjhj1okPs",
          price: 0,
          ptype: 1,
          quantity: 2,
          ratio: 1
        }]
      this.vhSalesWebAPPEndUser.createBill_Billdetail_42(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
     * @param bill
     * @param bill_details
     * @return Promise => object = {} or null
     */
    createBill_Billdetail_43(bill: any, bill_details: any): any;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt mua payment_card (bill_type = 52)
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        date: new Date(),
        tax: 0,
        fee: 0,
        total: 0,
      }
      let bill_details =[{
        id_payment_cardr: "pEvqDLsBEFaAROUbyqZV",
        id_payment_card_code: "njoaSkUIxkGVxBUyHN10",
        price: 500000,
        quantity: 1,
        ratio: 1,
        pctype: 1,
        products:[{
          id_product: "xmVt5uDH8jaajYJ1KmVo",
          price: 0, //vì bán thẻ nên giá sản phẩm luôn luôn là 0
          ptype: 1,
          quantity: 2,
          ratio: 1
        },{
          id_product: "PGtdEroQNKSJjhj1okPs",
          price: 0,
          ptype: 1,
          quantity: 2,
          ratio: 1
        }]
      this.vhSalesWebAPPEndUser.createBill_Billdetail_42(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
     * @param bill
     * @param bill_details
     * @return Promise => object = {} or null
     */
    createBill_Billdetail_52(bill: any, bill_details: any): any;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt đổi payment_card_code lấy sản phẩm (bill_type = 53)
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        date: new Date(),
        tax: 0,
        fee: 0,
        total: 200000,
      }
      let bill_details =[{
        id_payment_card: "pEvqDLsBEFaAROUbyqZV",
        id_payment_card_code: "njoaSkUIxkGVxBUyHN10",
        pctype: 1,
        products:[{
          id_product: "xmVt5uDH8jaajYJ1KmVo",
          price: 0, //vì đổi thẻ lấy hàng, nên giá sản phẩm luôn luôn là 0
          ptype: 1,
          quantity: 1, //đây là số lượng đổi trong hóa đơn đổi lấy hàng này
          outquantity: xem cách tính bên dưới,
          restquantity: xem cách tính bên dưới,
          ratio: 1
        },{
          id_product: "PGtdEroQNKSJjhj1okPs",
          price: 0, //vì đổi thẻ lấy hàng, nên giá sản phẩm luôn luôn là 0
          ptype: 1,
          quantity: 1, //đây là số lượng đổi trong hóa đơn đổi lấy hàng này
          outquantity: xem cách tính bên dưới,
          restquantity: xem cách tính bên dưới,
          ratio: 1
        }]
      this.vhSalesWebAPPEndUser.createBill_Billdetail_52(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
     * @param bill
     * @param bill_details
     * @return Promise => object = {} or null
     * @notice :
     * outquantity (của bill_detail) = outquantity (của thẻ) + quantity (của bill_detail);
     * restquantity (của bill_detail) = quantity (của thẻ) - outquantity (của bill_detail);
     */
    createBill_Billdetail_53(bill: any, bill_details: any): any;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.updateBill_detail('5fb6780ca2148e09806c5b01', {total:990000})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param id_bill
      * @param value : object
      * @return  Promise object => obj = {vcode, message)}
      */
    updateBill_detail(id_bill: string, value: any): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getBill_details('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_details = response.data;
            }
          },error=>{
              console.log('error', error)
          })
     *  @param id_bill
     *  @return  Promise object => obj = {vcode, message, data(array)} / error
     */
    private getBill_details;
    /**
   * @example
   this.vhSalesWebAPPEndUser.getBill_details_byId_bill('RcECbNgU9BdYQo37s30p')
        .then((bill_details)=>{
          console.log('getBill_details_byId_bill', bill_details);
        },(error:any)=>{
          console.log('error ', error);
        })
   * @param id_bill
   * @return Promise => array / orror
   */
    getBill_details_byId_bill(id_bill: any): any;
    /**
   * @example:
   * this.vhSalesWebAPPEndUser.getBill_detailsByFields({id_bill:{$eq:'38q90h9ehf9wyn4sjkdfa'}},{},{},0)
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_details = response.data;
            }
          },error=>{
              console.log('error', error)
          })
  * @param query
  * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
  * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
  * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
  * @return  Promise object => obj = {vcode, message, data(array)}
  */
    getBill_detailsByFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getBill_detail('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_detail = response.data;
            }
          },error=>{
              console.log('error', error)
          })
     *  @param id_bill_detail
     *  @return Promise => response ={vcode, message, data(object or null)} / error
     */
    getBill_detail(id_bill_detail: any): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.deleteBill_Detail('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
      * @param id_bill_detail
      * @return Promise => response.data = undefined / error
      */
    deleteBill_Detail(id_bill_detail: string): Promise<unknown>;
    /**
   * Lưu ý: xóa tất cả các bill_type(từ 1 đến 28, 40, 41, 50, 51) đều dùng hàm này, chưa có xóa bill_type 30 và 31
   * @example
   this.vhSalesWebAPPEndUser.deleteBill_Billdetail('RcECbNgU9BdYQo37s30p')
        .then((bool)=>{
          if(bool){
            console.log('success');
          }else{
            console.log('no success');
          }
        },(error:any)=>{
          console.log('error ', error);
        })
   * @param id_bill
   * @return Promise => null or orror
   */
    deleteBill_Billdetail(id_bill: any): any;
    private changeBillDetails_withPromotions_toRaw;
    private changeBillDetails_withRaw_toPromotions;
    /**
 * hàm này trả về voucher code đã phát hành theo trường _id của voucher code.
 * trả về có cả code, name_voucher, name_voucher_release
 * @example:
 *
 * this.vhSalesWebAPPEndUser.getVoucher_Code_Name_Release('OUHEDW0512'})
       .then((res)=>{
         console.log('getVoucher_Code_Name_Release', res);
       }, error=>{
         console.log('error', error);
       })
 * @param id_voucher_code: cũng chính là code
 * @return Promise => obj ={} or null
 */
    getVoucher_Code_Name_Release(id_voucher_code: any): Promise<unknown>;
    /**
    * @example:
    * this.vhSalesWebAPPEndUser.changeBillDetails_withNameUnitsLots(bill_details)
          .then((res)=>{
            console.log('changeBillDetails_withNameUnitsLots', res);
            let _bill_details = res;
          }, error=>{
            console.log('error', error);
          })
    * @param bill_details
    * @return  Promise => array = [{},{},...]
    * Luu ý: chỉ có 2 trường hợp, hoặc là thêm thành công, hoặc là báo lỗi error
    */
    private changeBillDetails_withNameUnitsLots;
    /**
    * hàm này trả về payment_card code đã phát hành theo trường _id của payment_card code
    * trả về có cả code, name_payment_card, name_payment_card_release
    * @example:
    *
    * this.vhSalesWebAPPEndUser.getPaymentCard_Code_Name_Release('OUHEDW0512'})
          .then((res)=>{
            console.log('getPaymentCard_Code_Name_Release', res);
          }, error=>{
            console.log('error', error);
          })
    * @param id_payment_card_code: cũng chính là code
    * @return Promise => obj ={} or null
    */
    getPaymentCard_Code_Name_Release(id_payment_card_code: any): Promise<unknown>;
    /**
   * @example:
   * this.vhSalesWebAPPEndUser.getBillDetails_withName({name:'promition 1'})
          .then((bill_details)=>{
            console.log('getBillDetails_withName', bill_details);
          },error=>{
            console.log('error', error);
          })
    * @param bill_details
    * @return  Promise => array = [{},{},...]
    * Luu ý: chỉ có 2 trường hợp, hoặc là thêm thành công, hoặc là báo lỗi error
    */
    private changeBillDetails_withPromotionNameUnitsLots;
    /**
     * @example:
     * this.vhSalesWebAPPEndUser.getDoc_fromDatabase('products', '5fb67fda87c0f21d484cbdf3')
          .then((product)=>{
            console.log('getDoc_fromDatabase', product);
          },error=>{
            console.log('error', error);
          })
      * @param colname
      * @param _id
      * @return Promise => obj ={} or null
      */
    private getDoc_fromDatabase;
}
export declare class VhSalesWebAPPAdmin {
    private vhAlgorithm;
    private camera;
    private imagePicker;
    private webview;
    private imgserverURL;
    private webappserverURL;
    private project;
    private dbstorage;
    private database;
    private store;
    private user;
    private branchs;
    constructor(vhAlgorithm: VhAlgorithm, camera: Camera, imagePicker: ImagePicker, webview: WebView);
    /**
     * @example:
     * this.vhSalesWebAPPAdmin.initializeProject('vhsales','firebase','research','research', 394637, '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2')
          .then(()=>{
            //-----------your code----------
          })
     * @param project
     * @param dbstorage
     * @param dbserverversion
     * @param camserverversion
     * @param fwcode
     * @param database : một database nào đó '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2'
     * @returns
     */
    initializeProject(project: string, dbstorage: string, dbserverversion: string, camserverversion: string, fwcode: number, database: string): Promise<any>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.searchList('products',["name", "describe"], 'Điện Thoại')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let array_searched_data = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param array_field
      * @param value
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    searchList(colname: string, array_field: any, value: string, limit: number, page: number): Promise<unknown>;
    /**
     * @example:Lấy hình ảnh từ Camera thiết bị
     *  this.vhSalesWebAPPAdmin.getThumbnailFromCamera(128, 128, "employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
     * @param w
     * @param h
     * @param folder
     * @param oldthumbnailURL
     * @returns
     */
    getThumbnailFromCamera(w: any, h: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Camera thiết bị
     *  this.vhSalesWebAPPAdmin.getImageFromCamera("employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
     * @param folder
     * @param oldthumbnailURL
     * @returns
     */
    getImageFromCamera(folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
       * @example:Lấy hình ảnh từ Album thiết bị
       *  this.vhSalesWebAPPAdmin.getThumbnailFromAlbum(128, 128, "employees", this.img).then(
            photoURL => {
              this.img = photoURL;
              this.detailEmployee.controls["img"].setValue(photoURL);
              this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
              this.updateEmployee(this.detailEmployee.value);
            },
            () => {
              this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
            }
          );
       * @param w
       * @param h
       * @param folder
       * @param oldthumbnailURL
       * @returns
       */
    getThumbnailFromAlbum(w: any, h: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Album thiết bị
     *  this.vhSalesWebAPPAdmin.getImageFromAlbum("employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
     * @param folder
     * @param oldthumbnailURL
     * @returns
     */
    getImageFromAlbum(folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
       * @example:Lấy hình ảnh từ Desktop
       * onUpload(e?) {
            const file = e.target.files[0];
            this.vhSalesWebAPPAdmin.getThumbnailFromDesktop(file, 128, 128, "employees", this.img).then(
              photoURL => {
                  this.img = photoURL;
                  this.detailEmployee.controls["img"].setValue(photoURL);
                  this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
                  this.updateEmployee(this.detailEmployee.value);
                }
              },error => {
                this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
              }
            );
      }
       * @param file
       * @param w
       * @param h
       * @param folder: tên của loại component, ví dụ webapp_product, webapp_category, webapp_news....
       * @param oldthumbnailURL : String
       * @returns
       * @notice: trường hợp cập nhật hình ảnh, phải truyền vào hàm tham số oldthumbnailURL để xóa ảnh cũ đi, tránh làm server bị rác
       */
    getThumbnailFromDesktop(file: any, w: any, h: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Desktop đẩy lên server với kích thước hình ko thay đổi
     * onUpload(e?) {
          const file = e.target.files[0];
          this.vhSalesWebAPPAdmin.getImageFromDesktop(file,"employees", this.img)
            .then((rsp:any)=>{
                console.log('rsp', rsp);
                if(rsp.vcode === 0){
                  this.img = rsp.data;
                  this.detailEmployee.controls["img"].setValue(this.img);
                  this.updateEmployee(this.detailEmployee.value);
                }else if(rsp.vcode === 1){
  
                }else if(rsp.vcode === 2){
  
                }else if(rsp.vcode === 3){
  
                }
                this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            },error => {
              this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
            }
          );
    }
     * @param file
     * @param folder: tên của loại component, ví dụ webapp_product, webapp_category, webapp_news....  hoặc sanpham/webapp_product, sanpham/webapp_category
     * @param oldthumbnailURL : String   *
     * @notice : trường hợp cập nhật hình ảnh, phải truyền vào hàm tham số oldthumbnailURL để xóa ảnh cũ đi, tránh làm server bị rác
     * @returns Object => obj = {vcode, message, data, error}
     * vcode === 0 : upload ảnh thành công
     * vcode === 1 : lỗi import file ảnh
     * vcode === 2 : lỗi upload file ảnh
     * vcode === 3 : không thể upload file ảnh lớn hơn 1Mb
     */
    getImageFromDesktop(file: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * vhSalesWebAPPAdmin
     * @param imageURI
     * @param type
     * @param w
     * @param h
     * @param filename
     * @param folder
     * @returns
     */
    private uploadThumbnail;
    /**
     * vhSalesWebAPPAdmin
     * @param imageURI
     * @param type :'image/jpeg'
     * @param w
     * @param h
     * @param filename
     * @param folder
     * @returns
     */
    private uploadImage;
    /**
     * vhSalesWebAPPAdmin
     * @param imageUri
     * @param type
     * @param w
     * @param h
     * @param callback
     */
    private encodeThumbnailUri;
    /**
     * vhSalesWebAPPAdmin
     * @param imageUri
     * @param type : 'image/jpeg'
     * @param w
     * @param h
     * @param callback
     */
    private encodeImageUri;
    /**
     *@example
        this.vhSalesWebAPPAdmin.deleteThumbnail([url_img, url_img1])
            .then(()=>{
              //-----------your code here-----------
            },error=>{
                console.log('error', error)
            })
     * @param thumbnailURL : Array
     * @returns Promise => true or false
     */
    deleteThumbnail(thumbnailURL: any): Promise<any>;
    /**
     * vhSalesWebAPPAdmin
     * @param base64image
     * @param filename
     * @param folder
     * @returns
     */
    private uploadBase64Image_onFirebase;
    /**
     * vhSalesWebAPPAdmin
     * example:
     *
     * @param base64image
     * @param filename
     * @param folder
     * @returns
     */
    private uploadBase64Image_onViethas;
    /**
     * @example:
     * this.deleteImage_onFirebase(thumbnailURL[i])
            .then(()=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
     * @param imageURL
     * @returns
     */
    private deleteImage_onFirebase;
    /**
     * @example:
     * this.deleteImage_onViethas(thumbnailURL[i])
            .then(()=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
     * @param imageURL
     * @returns
     */
    deleteImage_onViethas(imageURL: string): Promise<unknown>;
    /**
     * Lấy về danh sách thư mục, file trong thư mục định vị bởi đường dẫn path
     * @example:
       this.vhSalesWebAPPAdmin.getFilenames_onViethas("hinhanh/hinh")
            .then((child_list)=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
      * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
      * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
      */
    getFilenames_onViethas(path: string): Promise<unknown>;
    /**
     * Tạo thư mục mới trong thư mục định vị bởi đường dẫn path
     * @example:
       this.vhSalesWebAPPAdmin.createFolder_onViethas("hinhanh", "hinh")
            .then((child_list)=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
      * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
      * @param folder : tên thư mục
      * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
      */
    createFolder_onViethas(path: string, folder: string): Promise<unknown>;
    /**
   * Xóa thư mục, file (đang có) trong thư mục định vị bởi đường dẫn path
   * @example:
     this.vhSalesWebAPPAdmin.deleteFolder_onViethas("hinhanh", "hinh")
          .then((child_list)=> {
            //your code here...
          },error=>{
            console.log('error', error);
          })
    * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
    * @param folder : tên thư mục
    * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
    */
    deleteFolder_onViethas(path: string, folder: string): Promise<unknown>;
    /**
   * Đổi tên thư mục (đang có) trong thư mục định vị bởi đường dẫn path thành tên khác
   * @example:
     this.vhSalesWebAPPAdmin.renameFolder_onViethas("hinhanh", "hinh")
          .then((child_list)=> {
            //your code here...
          },error=>{
            console.log('error', error);
          })
    * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
    * @param folder : tên thư mục
    * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
    */
    renameFolder_onViethas(path: string, oldfolder: string, newfolder: string): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.addComponentContent('webapp_abouts', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addComponentContent(colname: string, data: object): Promise<unknown>;
    /**
     * Hàm này dùng đối với các component chỉ có 1 record dữ liệu duy nhất như component giới thiếu, componet liên lạc....
     * @example
     * this.vhSalesWebAPPAdmin.setComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param id_componentcontent : lấy theo tên của component
      * @param data : tất cả các trường của doc/recort
      * @return  Promise object => response = {vcode, message}
      */
    setComponentContent(colname: string, id_componentcontent: string, data: object): Promise<unknown>;
    /**
  * @example
  * this.vhSalesWebAPPAdmin.updateComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
           .then(response=>{
             console.log('response', response);
             if(response.vcode === 0){
                 //-----------your code-----------
             }
           },error=>{
               console.log('error', error)
           })
   * @param colname
   * @param id_componentcontent
   * @param value
   * @return  Promise object => response = {vcode, message}
   */
    updateComponentContent(colname: string, id_componentcontent: string, value: object): Promise<unknown>;
    /**
   * @example
   * this.vhSalesWebAPPAdmin.deleteComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message}
    */
    deleteComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
   * @example
   * this.vhSalesWebAPPAdmin.getComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPAdmin.getComponentContentsByFields('webapp_abouts', {name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getComponentContentsByFields(colname: string, query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.getComponentContents('webapp_abouts')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    getComponentContents(colname: string): Promise<unknown>;
    getStore(): any;
    getUser(): any;
    /**
      * @example:
      * this.vhSalesWebAPPAdmin.signin_byEmail('salesf110@gmail.com','h674567')
            .then(response=>{
               console.log('response', response);
               if(response.vcode === 0){
                   //-----------your code-----------
               }else if(response.vcode === 1){
                   //-----------your code 1-----------
               }else if(response.vcode === 2){
                   //-----------your code 2-----------
               }else if(response.vcode === 3){
                   //-----------your code 3-----------
               }
            },error=>{
               console.log('error', error)
            })
      * @param email
      * @param password
      * @return Promise object => response = {vcode, message}
      * vcode == 0: Signed in successfully
      * vcode == 1: Wrong email
      * vcode == 2: Wrong password
      * vcode == 3: Email address does not exist on my system
      */
    signin_byEmail(email: string, password: string): Promise<any>;
    /**
     * @example:
     * this.vhSalesWebAPPAdmin.onAuthStateChanged()
           .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }else{
                //-----------your code-----------
                signin_byEmail lại
              }
           },error=>{
              console.log('error', error)
           })
     * @return Promise object => response = {vcode, message}
     * vcode == 0: Signed in successfully
     */
    onAuthStateChanged(): Promise<any>;
    /**
   * @example
   * this.vhSalesWebAPPAdmin.signoutWebAPP()
   * @returns Void
   */
    signout(): void;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.addProduct({})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addProduct(data: object): Promise<unknown>;
    /**
   * @example
   * this.vhSalesWebAPPAdmin.updateProduct('5fb67fda87c0f21d484cbdf3', {})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_product
    * @param value
    * @return  Promise object => response = {vcode, message}
    */
    updateProduct(id_product: string, value: object): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.deleteProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message}
      */
    deleteProduct(id_product: any): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.getProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getProduct(id_product: any): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPAdmin.getProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.getNewProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    private getNewProduct;
    /**
     * @example:
     * this.vhSalesWebAPPAdmin.getNewProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    private getNewProductsByFields;
    /**
   * @example
   * let id_sub_or_product = id_subproduct?id_subproduct:id_product;
   * this.vhSalesWebAPPAdmin.getDetailProduct(id_sub_or_product)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_sub_or_product
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getDetailProduct(id_sub_or_product: any): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPAdmin.getDetailProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getDetailProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
   * hàm này tạo product và thêm subs vào product (lần đầu)
   * Lưu ý: trong product, subProductArray không có các trường quantity, quantity_branch và subs
  * @example:
  * @case 1: manysize (false)
  * let product = {
       allow_sell: true,
       brand: "OEM",
       id_category: "vTr90aYfhDqSCyuRh4DR",
       img: "image link",
       manysize: false,
       name: "test ko sub 3",
       selling: true,
       type: 1,
       warning_number: 3,
       units:[{
         barcode: "3103",
         price: 3100,
         price2: 3101,
         price_import: 3102,
         ratio: 1,
         unit: "Cái"
       }]
  * }
  * @case 2: manysize (true)
  * let product = {
       allow_sell: true,
       brand: "OEM",
       id_category: "vTr90aYfhDqSCyuRh4DR",
       img: "image link",
       manysize: true,
       name: "test sub 4",
       selling: true,
       type: 1,
       warning_number: 3,
       units:[{
         ratio: 1,
         unit: "Cái"
       },{
         barcode: "4203",
         price: 4200,
         price2: 4101,
         price_import: 4202,
         ratio: 10,
         unit: "Hộp"
       }]
    }
    let subProductArray = [{
       barcode: "43004",
       name: "Lớn",
       price: 43000,
       price2: 43002,
       price_import: 43001,
       warning_number: 43003
    }]
  * this.vhSalesWebAPPAdmin.addProductAndSubsProduct(product,subProductArray)
       .then(response=>{
         console.log('response', response);
         if(response.vcode === 0){
             //-----------your code-----------
         }
       },error=>{
           console.log('error', error)
       })
  * @param product
  * @param subProductArray
  * @return  Promise object => response = {vcode, message}
  * Luu ý: chỉ có 2 trường hợp, hoặc là thêm thành công trả về null (resolve), hoặc là thất bại trả về error (reject)
  */
    addProductAndSubsProduct(product: any, subProductArray: any): Promise<unknown>;
    /**
     * Hàm này cập nhật lại những thay đổi trong sub (cỡ) của sản phẩm
     * @example:
     * this.vhSalesWebAPPAdmin.updateSubProduct('5fb6780ca2148e09806c5b01', {quantity:400})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param id_subproduct
      * @param data
      * @return  Promise object => response = {vcode, message}
      */
    updateSubProduct(id_subproduct: string, value: any): Promise<unknown>;
    /**
      * Hàm này thêm Sub vào Product
     * @example:
     *  let subProduct ={
          allow_sell: true,
          manylot: true,
          name: "Lớn",
          selling: true,
          type: 1,
          warning_number: 5,
          units:[{
            barcode: "384807544448",
            default: true,
            price: 70000,
            price2: 60000,
            price_import: 50000,
            ratio: 1,
            unit: "Cái"
          }],
          days_exp_warning: 30,
          days_import_warning: 60,
          lots:[{
            _id: "tgwOaMDVmQaHfaL8FD02SMl9"
            barcode: "337953449785"
            date_exp: 'October 7, 2022 at 11:59:59 PM UTC+7'
            date_mfg: 'March 1, 2022 at 12:00:00 AM UTC+7'
            hidden: false
            lot_number: "lo1101"
          }]
        }
        this.vhSalesWebAPPAdmin.addSubProduct('5fb6780ca2148e09806c5b01',{price:0, name:'small'})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
     * @param id_product
     * @param subProduct
     *@return  Promise object => response = {vcode, message, data(object)}
     */
    addSubProduct(id_product: string, subProduct: any): Promise<unknown>;
    /**
     * Hàm này xóa sản phẩm con trong sản phẩm cha
     * @example:
     * this.vhSalesWebAPPAdmin.deleteSubProduct('5fb67fda87c0f21d484cbdf3')
           .then((rsp)=>{
              if(rsp.vcode === 0){
                  //-----------your code 0-----------
              }else if(rsp.vcode === 1){
                  //-----------your code 1-----------
              }else if(rsp.vcode === 2){
                  //-----------your code 2-----------
              }
          }, error=>{
            reject(error)
          })
      * @param id_subproduct
      * @return Observable object => rsp = {vcode, message}
      * vcode == 0: xóa thành công
      * vcode == 1: Bạn không thể xóa, vì sản phẩm con này đang liên kết với sản phẩm combo khác
      * vcode == 2: Bạn không thể xóa, vì sản phẩm con này đã phát sinh hóa đơn
      */
    deleteSubProduct(id_subproduct: string): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.addCategory({})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let category = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addCategory(data: object): Promise<unknown>;
    /**
   * @example
   * this.vhSalesWebAPPAdmin.updateCategory('5fb67fda87c0f21d484cbdf3', {})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_category
    * @param value
    * @return  Promise object => response = {vcode, message}
    */
    updateCategory(id_category: any, value: any): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.deleteCategory('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_category
      * @return  Promise object => response = {vcode, message}
      */
    deleteCategory(id_category: any): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.getCategory('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let category = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_category
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getCategory(id_category: any): Promise<unknown>;
    /**
     * @example:
     * this.vhSalesWebAPPAdmin.getCategorysByFields({name:{$eq:'name abc'}}, {},{},6, 1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let categorys = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getCategorysByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.getBranch('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.data.vcode === 0){
                    //-----------your code-----------
                    let branch = response.data.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_branch
      * @return  Promise object => obj = {vcode, message, data(object)}
      */
    private getBranch;
    /**
     * @example
     * this.vhSalesWebAPPAdmin.getBranchs()
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let branchs = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    private getBranchs;
    /**
     * @example:
     * let branch = this.vhSalesWebAPPAdmin.getlocalBranch('5fb6780ca2148e09806c5b01');
     * @param id_branch
     * @return Object => obj = {} or null
     */
    getlocalBranch(id_branch: any): any;
    /**
     * @example:
     * let branchs = this.vhSalesWebAPPAdmin.getlocalBranchs();
     * @return Array(object) => array = [{},{},...]
     */
    getlocalBranchs(): any[];
    /**
     * Sau khi đăng nhập vào giao diện quản trị (admin) khởi động xong và vào trang chính xong thì dùng hàm getDefaultBranch() lấy chi nhánh mặc định về (lưu ở local), sẽ có 2 trường hợp xảy ra:
     * + Trường hợp lấy về khác null thì kiểm tra chi nhánh này có tồn tại ở database không (dùng hàm getlocalBranch()). Nếu tồn tại thì
     * không có vấn đề gì xảy ra. Nếu không tồn tại thì hiển thị popup có các chi nhánh lên để khách chọn và lưu vô local
     * (dùng hàm setDefaultBranch()), lưu ý nếu có 1 chi nhánh thôi thì setDefaultBranch luôn, khỏi phải hiện popup ra làm chi
     * + Trường họp lấy về bằng null hiển thị popup có các chi nhánh lên để khách chọn và lưu vô local (dùng hàm setDefaultBranch()),
     * lưu ý nếu có 1 chi nhánh thôi thì setDefaultBranch luôn, khỏi phải hiện popup ra làm chi
     * @example:
     * this.vhSalesWebAPPAdmin.setDefaultBranch('Stbaw79rRVVIm2US55kh');
     * @param branch : lấy branch này y chang từ getlocalBranchs() và truyền vào hàm
     * @returns void
     */
    setDefaultBranch(id_branch: object): void;
    /**
     * @example:
     * this.vhSalesWebAPPAdmin.getDefaultBranch();
     * @returns object or null
     */
    getDefaultBranch(): any;
    /**
     * @example:
     * this.vhSalesWebAPPAdmin.getDefaultBranch();
     * @returns void
     */
    clearDefaultBranch(): void;
}
export declare class VhCafeWebAPPEndUser {
    private vhAlgorithm;
    private webappserverURL;
    private project;
    private dbstorage;
    private database;
    private store;
    private user;
    private singedin;
    private branchs;
    constructor(vhAlgorithm: VhAlgorithm);
    /**
     * @example:
     * this.vhCafeWebAPPEndUser.initializeProject('vhcafe','firebase','research','research', 394637, '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2')
          .then(()=>{
            //-----------your code----------
          })
     * @param project
     * @param dbstorage
     * @param dbserverversion
     * @param camserverversion
     * @param fwcode
     * @param database : một database nào đó '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2'
     * @returns
     */
    initializeProject(project: string, dbstorage: string, dbserverversion: string, camserverversion: string, fwcode: number, database: string): Promise<any>;
    getStore(): any;
    getUser(): any;
    /**
     * @example
     * this.vhCafeWebAPPEndUser.addComponentContent('webapp_abouts', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addComponentContent(colname: string, data: object): Promise<unknown>;
    /**
     * Hàm này dùng đối với các component chỉ có 1 record dữ liệu duy nhất như component giới thiếu, componet liên lạc....
     * @example
     * this.vhCafeWebAPPEndUser.setComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param id_componentcontent : lấy theo tên của component
      * @param data : tất cả các trường của doc/recort
      * @return  Promise object => response = {vcode, message}
      */
    setComponentContent(colname: string, id_componentcontent: string, data: object): Promise<unknown>;
    /**
 * @example
 * this.vhCafeWebAPPEndUser.updateComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
  * @param colname
  * @param id_componentcontent
  * @param value
  * @return  Promise object => response = {vcode, message}
  */
    updateComponentContent(colname: string, id_componentcontent: string, value: object): Promise<unknown>;
    /**
   * @example
   * this.vhCafeWebAPPEndUser.deleteComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message}
    */
    deleteComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
   * @example
   * this.vhCafeWebAPPEndUser.getComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
     * @example:
     * this.vhCafeWebAPPEndUser.getComponentContentsByFields('webapp_abouts', {name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getComponentContentsByFields(colname: string, query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhCafeWebAPPEndUser.getComponentContents('webapp_abouts')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    getComponentContents(colname: string): Promise<unknown>;
    /**
     * @example
     * this.vhCafeWebAPPEndUser.searchList('detailproducts',["name", "describe"], 'Điện Thoại', 20, 1)
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let array_searched_data = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param array_field
      * @param value
      * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
      * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
      * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
      */
    searchList(colname: string, array_field: any, value: string, limit: number, page: number): Promise<unknown>;
    /**
       * @example:
       * this.vhCafeWebAPPEndUser.forgotPassword_byEmail('cafef110@gmail.com','h674567')
             .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code 0-----------
                    let user = response.data;
                }else if(response.vcode === 1){
                    //-----------your code 1-----------
                }
             },error=>{
                console.log('error', error)
             })
       * @param email
       * @param password
       * @return Promise object => response = {vcode, message}
       * vcode == 0: Message sent to email address successfully
       * vcode == 1: Email address does not exist
       */
    forgotPassword_byEmail(email: string, password: string): Promise<any>;
    /**
     * @example:
     * this.vhCafeWebAPPEndUser.changePassword_byEmail('cafef110@gmail.com','h674567', 'V12345678')
           .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code 0-----------
                  let user = response.data;
              }else if(response.vcode === 1){
                  //-----------your code 1-----------
              }else if(response.vcode === 2){
                  //-----------your code 2-----------
              }else if(response.vcode === 3){
                  //-----------your code 3-----------
              }
           },error=>{
              console.log('error', error)
           })
     * @param email
     * @param oldpassword
     * @param newpassword
     * @return Promise object => response = {vcode, message}
     * vcode == 0: Message sent to email address successfully
     * vcode == 1: Email address does not exist
     * vcode == 2: wrong oldpassword
     * vcode == 3: please reset your password
     */
    changePassword_byEmail(email: string, oldpassword: string, newpassword: string): Promise<any>;
    /**
       * @example:
       * this.vhCafeWebAPPEndUser.signup_byEmail('cafef110@gmail.com','h674567',{})
             .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code 1-----------
                    let enduser = response.data;
                }else if(response.vcode === 1){
                    //-----------your code 2-----------
                }
             },error=>{
                console.log('error', error)
             })
       * @param email
       * @param password
       * @param info : thông tin của enduser
       * @return Promise object => response = {vcode, message, data}
       * vcode == 0: User account registered successful
       * vcode == 1: User Email already exists
       * @notice : sau khi đăng ký thành công, người dùng phải vào email xác nhận xác nhận việc đăng ký này
       */
    signup_byEmail(email: string, password: string, info: object): Promise<any>;
    /**
       * @example:
       * this.vhCafeWebAPPEndUser.signin_byEmail('cafef110@gmail.com','h674567')
             .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code 0-----------
                    let user = response.data;
                }else if(response.vcode === 1){
                    //-----------your code 1-----------
                }else if(response.vcode === 2){
                    //-----------your code 2-----------
                }else if(response.vcode === 3){
                    //-----------your code 3-----------
                }else if(response.vcode === 4){
                    //-----------your code 4-----------
                }
             },error=>{
                console.log('error', error)
             })
       * @param email
       * @param password
       * @return Promise object => response = {vcode, message, data}
       * vcode == 0: Signed in successfully
       * vcode == 1: Wrong email
       * vcode == 2: Please login into your email to confirm your account on my website or APP
       * vcode == 3: Please reset your password
       * vcode == 4: Wrong password
       */
    signin_byEmail(email: string, password: string): Promise<any>;
    /**
     * Hàm này cập nhật thông tin người dùng webapp (người dùng đã nhập vào webapp mới cập  nhật được)
     * @example:
     * this.vhCafeWebAPPEndUser.updateUser('5fb6780ca2148e09806c5b01', {name:'Nguyễn Văn A'})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param value : object
      * @return  Promise object => response = {vcode, message)}
      */
    updateUser(value: object): Promise<unknown>;
    /**
     * Hàm này xóa email người dùng webapp (người dùng đã nhập vào webapp mới xóa được)
     * @example:
     * this.vhCafeWebAPPEndUser.deleteUser()
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  //thoát ra trang chưa  đăng nhập
              }
            },error=>{
                console.log('error', error)
            })
      * @return  Promise object => response = {vcode, message)}
      * vcode == 0: Deleted successfully
      */
    deleteUser(): Promise<unknown>;
    /**
   * @example:
   * this.vhCafeWebAPPEndUser.onAuthStateChanged()
         .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code 0-----------
                let user = response.data;
            }else if(response.vcode === 1){
                //-----------your code 1-----------
            }else if(response.vcode === 2){
                //-----------your code 2-----------
            }else if(response.vcode === 3){
                //-----------your code 3-----------
            }else if(response.vcode === 4){
                //-----------your code 4-----------
            }
         },error=>{
            console.log('error', error)
         })
   * @return Promise object => response = {vcode, message}
   * vcode == 0: Signed in successfully
   * vcode == 1: wrong access_token->email
   * vcode == 2: wrong access_token->password
   * vcode == 3: Please login into your email to confirm your account on my website or APP
   * vcode == 4: Please reset your password
   */
    onAuthStateChanged(): Promise<any>;
    /**
    * @example
    * this.vhCafeWebAPPEndUser.signout();
    * @return void
    */
    signout(): void;
    /**
     * @example
     * let bool = this.vhCafeWebAPPEndUser.checkSignin();
     * @return Boolean => true or false
     */
    checkSignin(): any;
    /**
     * @example
     * this.vhCafeWebAPPEndUser.getProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getProduct(id_product: any): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
    * @example
    * this.vhCafeWebAPPEndUser.getNewProduct('5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_product
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    private getNewProduct;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getNewProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    private getNewProductsByFields;
    /**
    * @example
    * let id_sub_or_product = id_subproduct?id_subproduct:id_product;
    * this.vhCafeWebAPPEndUser.getDetailProduct(id_sub_or_product)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_sub_or_product
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getDetailProduct(id_sub_or_product: any): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getDetailProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getDetailProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
    * @example
    * this.vhCafeWebAPPEndUser.getCategory('5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let category = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_category
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getCategory(id_category: any): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getCategorysByFields({name:{$eq:'name abc'}}, {},{},6, 1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let categorys = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getCategorysByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
    * @example
    * this.vhCafeWebAPPEndUser.getBranch('5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.data.vcode === 0){
                  //-----------your code-----------
                  let branch = response.data.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_branch
    * @return  Promise object => obj = {vcode, message, data(object)}
    */
    private getBranch;
    /**
    * @example
    * this.vhCafeWebAPPEndUser.getBranchs(')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let branchs = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @return  Promise object => response = {vcode, message, data(array)}
    */
    private getBranchs;
    /**
      * @example:
      * let branch = this.vhCafeWebAPPEndUser.getlocalBranch('5fb6780ca2148e09806c5b01');
      * @param id_branch
      * @return Object => obj = {} or null
      */
    getlocalBranch(id_branch: any): any;
    /**
      * @example:
      * let branchs = this.vhCafeWebAPPEndUser.getlocalBranchs();
      * @return Array(object) => array = [{},{},...]
      */
    getlocalBranchs(): any[];
    /**
      * Khi giao diện người dùng (user) khởi động xong và vào trang chủ xong thì dùng hàm getDefaultBranch() lấy chi nhánh mặc định về (lưu ở local), sẽ có 2 trường hợp xảy ra:
      * + Trường hợp lấy về khác null thì kiểm tra chi nhánh này có tồn tại ở database không (dùng hàm getlocalBranch()). Nếu tồn tại thì
      * không có vấn đề gì xảy ra. Nếu không tồn tại thì hiển thị popup có các chi nhánh lên để khách chọn và lưu vô local
      * (dùng hàm setDefaultBranch()), lưu ý nếu có 1 chi nhánh thôi thì setDefaultBranch luôn, khỏi phải hiện popup ra làm chi
      * + Trường họp lấy về bằng null hiển thị popup có các chi nhánh lên để khách chọn và lưu vô local (dùng hàm setDefaultBranch()),
      * lưu ý nếu có 1 chi nhánh thôi thì setDefaultBranch luôn, khỏi phải hiện popup ra làm chi
      * @example:
      * this.vhCafeWebAPPEndUser.setDefaultBranch('Stbaw79rRVVIm2US55kh');
      * @param branch : lấy branch này y chang từ getlocalBranchs() và truyền vào hàm
      * @returns void
      */
    setDefaultBranch(id_branch: object): void;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getDefaultBranch();
      * @returns object or null
      */
    getDefaultBranch(): any;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getDefaultBranch();
      * @returns void
      */
    clearDefaultBranch(): void;
    /**
    * Hàm này trả về thông tin hạng của khách hàng (sau khi đã đăng nhập)
      * @example:
      * this.vhCafeWebAPPEndUser.getCustomerClass()
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                if(response.data){
                  let customer_class = response.data;
                }else{
                  //Khách hàng này chưa có hạng (nhờ chủ cửa hàng phân hạng cho họ)
                }
            }
          },error=>{
              console.log('error', error)
          })
      *  @return Promise => payment ={vcode, message, data(object or null)} / error
      *  @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
      */
    getCustomerClass(): Promise<unknown>;
    /**
      * Hàm này lấy về một mã coupon tương ứng với 1 đợt phát hành (đang cho phép phát hành)
      * Khách hàng của các cửa hàng khi vào web hoặc app của cửa hàng sẽ thấy được các đợt phát hành coupon (đang cho phép phát hành),
      * tương ứng với mỗi đợt phát hành này web/app sẽ sinh ra một mã coupon mới gọi là mã coupon chưa phát hành (nó chỉ mới sinh ra ở web/app thôi chưa có trên database),
      * khi nào khách hàng đổi điểm để lấy mã coupon này thì trên database mới phát hành và đổi điểm của khách luôn (nghĩa là trên database, mã coupon này ko có ở status_1 mà khi đổi điểm tạo thẳng status_3 luôn)
      * @example:
      * this.vhCafeWebAPPEndUser.getCouponCodes_Not_Release()
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let coupon_codes = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @return  Promise object => obj = {vcode, message, data(array)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    getCouponCodes_Not_Release(): Promise<unknown>;
    /**
    * Hàm này lấy về tất cả các mã coupon mà khách hàng đang sở hữu, đó là mã coupon đã đổi điểm (status_3) và mã coupon đã dùng để thanh toán (status_4)
    * @example:
    * this.vhCafeWebAPPEndUser.getCouponCodes_Owned()
          .then(response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let coupon_codes = response.data;
            }
          },error=>{
              console.log('error', error)
          })
  * @return  Promise object => obj = {vcode, message, data(array)}
  * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
  */
    getCouponCodes_Owned(): Promise<unknown>;
    /**
    * hàm này để đổi phiếu từ điểm của khách hàng. Đổi thành công tự động tạo lịch sử đổi điểm của khách hàng
    * hàm này đã tạo mới mã coupon với status_3 (trường hợp này ko tồn tại status_1)
    * hàm này đã cập nhật lại trường earned_points, id_customer, branch_earned_points cho khách hàng
    * @example:
    * let array = [{id_coupon_code, points, value},{}...]
    * this.vhCafeWebAPPEndUser.exchangeCouponCode_byEarningPoints(coupon_code_not_release)
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let coupon_codes = response.data;
            }
          },error=>{
              console.log('error', error)
          })
    * @param coupon_code_not_release : {code, date_expire, date_validity, id_branch, id_coupon, id_coupon_release_detail, name_coupon, name_coupon_release, points, value} (lấy nguyên coupon_code_not_release đã có sẳn)
    * @return  Promise object => obj = {vcode, message, data(coupon_code)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    exchangeCouponCode_byEarningPoints(coupon_code_not_release: any): Promise<unknown>;
    /**
    * Hàm này dùng cập nhật lại các trường của mã coupon.
    * Lưu ý trường status_9 là trạng thái mã coupon thanh toán cho đơn đặt hàng bill_type 36,
    * sau khi đơn đặt hàng chuyển sang đơn mua hàng bill_type 1 thì status sẽ chuyển sang 4
    * @example:
    * let value ={status:9, id_bill: "5fb67fda87c0f21d484cbdf3", date_use_ordered: new Date(), id_customer_used: 'SNYgA1NE0ZqtFdwVkTMz'}
    * this.vhCafeWebAPPEndUser.updateCouponCode('YrgePVXyz3VDEFMKG2xA', value)
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
              let customer_class = response.data;
          }
        },error=>{
            console.log('error', error)
        })
    * @param id_coupon_code : id của mã coupon
    * @param value : {status, id_bill, date_used, id_customer_used}
    * @return Promise => payment ={vcode, message, data(undefined)} / error
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    updateCouponCode(id_coupon_code: string, value: object): Promise<unknown>;
    /**
      * Hàm này lấy về một mã voucher tương ứng với 1 đợt phát hành (đang cho phép phát hành)
      * Khách hàng của các cửa hàng khi vào web hoặc app của cửa hàng sẽ thấy được các đợt phát hành voucher (đang cho phép phát hành),
      * tương ứng với mỗi đợt phát hành này web/app sẽ sinh ra một mã voucher mới gọi là mã voucher chưa phát hành (nó chỉ mới sinh ra ở web/app thôi chưa có trên database),
      * khi nào khách hàng đổi điểm để lấy mã voucher này thì trên database mới phát hành và đổi điểm của khách luôn (nghĩa là trên database, mã voucher này ko có ở status_1 mà khi đổi điểm tạo thẳng status_3 luôn)
      * @example:
      * this.vhCafeWebAPPEndUser.getVoucherCodes_Not_Release()
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let voucher_codes = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @return  Promise object => obj = {vcode, message, data(array)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    getVoucherCodes_Not_Release(): Promise<unknown>;
    /**
    * Hàm này lấy về tất cả các mã voucher mà khách hàng đang sở hữu, đó là mã voucher đã đổi điểm (status_3) và mã voucher đã dùng để thanh toán (status_4)
    * @example:
    * this.vhCafeWebAPPEndUser.getVoucherCodes_Owned()
          .then(response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let voucher_codes = response.data;
            }
          },error=>{
              console.log('error', error)
          })
  * @return  Promise object => obj = {vcode, message, data(array)}
  * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
  */
    getVoucherCodes_Owned(): Promise<unknown>;
    /**
  * hàm này để đổi mã voucher từ điểm của khách hàng. Đổi thành công tự động tạo lịch sử đổi điểm của khách hàng
  * hàm này đã tạo mới mã voucher với status_3 (trường hợp này ko tồn tại status_1)
  * hàm này đã cập nhật lại trường earned_points, id_customer, branch_earned_points cho khách hàng
  * @example:
  * this.vhCafeWebAPPEndUser.exchangeVoucherCode_byEarningPoints(voucher_code_not_release)
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
              let voucher_codes = response.data;
          }
        },error=>{
            console.log('error', error)
        })
  * @param voucher_code_not_release : {code, date_expire, date_validity, id_branch, id_voucher, id_voucher_release_detail, name_voucher, name_voucher_release, points, value} (lấy nguyên voucher_code_not_release đã có sẳn ở hàm getVoucherCodes_Not_Release())
  * @return  Promise object => obj = {vcode, message, data(voucher_code)}
  * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
  */
    exchangeVoucherCode_byEarningPoints(voucher_code_not_release: any): Promise<unknown>;
    /**
    * hàm này để chọn 1 voucher_code thuộc chương trình bán hàng đưa vào giỏ hàng, sau đó khách sẽ tiến hành đặt mua
    * hàm này đã tạo mới mã voucher với status_6 (trường hợp này ko tồn tại status_1)
    * @example:
    * this.vhCafeWebAPPEndUser.createVoucherCode_6(voucher_code_not_release)
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let voucher_codes = response.data;
            }
          },error=>{
              console.log('error', error)
          })
    * @param voucher_code_not_release : {code, date_expire, date_validity, id_branch, id_voucher, id_voucher_release_detail, name_voucher, name_voucher_release, points, value} (lấy nguyên voucher_code_not_release đã có sẳn ở hàm getVoucherCodes_Not_Release())
    * @return  Promise object => obj = {vcode, message, data(voucher_code)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    createVoucherCode_6(voucher_code_not_release: any): Promise<unknown>;
    /**
    * Hàm này bỏ chọn 1 mã voucher_code mà khách đã được chọn để mua trước đó (status_6)
    * @example:
    * this.vhCafeWebAPPEndUser.deleteVoucherCode_6('5fb67fda87c0f21d484cbdf3')
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
          }
        },error=>{
            console.log('error', error)
        })
    * @param id_voucher_code
    * @return Promise => response.data = undefined / error
    */
    deleteVoucherCode_6(id_voucher_code: string): Promise<unknown>;
    /**
    * Hàm này chọn 1 voucher_code có status 2 hoặc 3 chuyển sang status 8 (trạng thái "chọn đổi voucher hàng hóa")
    * @example:
    * this.vhCafeWebAPPEndUser.changeVoucherCode_2or3_to8('5fb67fda87c0f21d484cbdf3')
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
          }
        },error=>{
            console.log('error', error)
        })
    * @param id_voucher_code
    * @return Promise => response.data = undefined / error
    */
    changeVoucherCode_2or3_to8(id_voucher_code: string): Promise<unknown>;
    /**
    * @example:
    * this.vhCafeWebAPPEndUser.getVoucherCodes_byFields({status:{$in:[2,3]}}, {},{},0)
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bills = response.data;
            }
          },error=>{
              console.log('error', error)
          })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @return  Promise object => obj = {vcode, message, data(array)}
    */
    getVoucherCodes_byFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    /**
    * Hàm này dùng cập nhật lại các trường của mã voucher.
    * @example:
    * let value ={status:9, id_bill: "5fb67fda87c0f21d484cbdf3", date_use_ordered: new Date(), id_customer_used: 'SNYgA1NE0ZqtFdwVkTMz'}
    * this.vhCafeWebAPPEndUser.updateVoucherCode('YrgePVXyz3VDEFMKG2xA', value)
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
              let customer_class = response.data;
          }
        },error=>{
            console.log('error', error)
        })
    * @param id_voucher_code : id của mã voucher
    * @param value : {status, id_bill, date_used, id_customer_used}
    * @return Promise => payment ={vcode, message, data(undefined)} / error
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    updateVoucherCode(id_voucher_code: string, value: object): Promise<unknown>;
    /**
      * Hàm này lấy về một mã payment_card tương ứng với 1 đợt phát hành (đang cho phép phát hành)
      * Khách hàng của các cửa hàng khi vào web hoặc app của cửa hàng sẽ thấy được các đợt phát hành payment_card (đang cho phép phát hành),
      * tương ứng với mỗi đợt phát hành này web/app sẽ sinh ra một mã payment_card mới gọi là mã payment_card chưa phát hành (nó chỉ mới sinh ra ở web/app thôi chưa có trên database),
      * khi nào khách hàng đổi điểm để lấy mã payment_card này thì trên database mới phát hành và đổi điểm của khách luôn (nghĩa là trên database, mã payment_card này ko có ở status_1 mà khi đổi điểm tạo thẳng status_3 luôn)
      * @example:
      * this.vhCafeWebAPPEndUser.getPaymentCardCodes_Not_Release()
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let payment_card_codes = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @return  Promise object => obj = {vcode, message, data(array)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    getPaymentCardCodes_Not_Release(): Promise<unknown>;
    /**
    * Hàm này lấy về tất cả các mã payment_card mà khách hàng đang sở hữu, đó là mã payment_card đã đổi điểm (status_3) và mã payment_card đã dùng để thanh toán (status_4)
    * @example:
    * this.vhCafeWebAPPEndUser.getPaymentCardCodes_Owned()
          .then(response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let payment_card_codes = response.data;
            }
          },error=>{
              console.log('error', error)
          })
  * @return  Promise object => obj = {vcode, message, data(array)}
  * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
  */
    getPaymentCardCodes_Owned(): Promise<unknown>;
    /**
  * hàm này để đổi mã payment_card từ điểm của khách hàng. Đổi thành công tự động tạo lịch sử đổi điểm của khách hàng
  * hàm này đã tạo mới mã payment_card với status_3 (trường hợp này ko tồn tại status_1)
  * hàm này đã cập nhật lại trường earned_points, id_customer, branch_earned_points cho khách hàng
  * @example:
  * let array = [{id_payment_card_code, points, value},{}...]
  * this.vhCafeWebAPPEndUser.exchangePaymentCardCode_byEarningPoints(payment_card_code_not_release)
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
              let payment_card_codes = response.data;
          }
        },error=>{
            console.log('error', error)
        })
  * @param payment_card_code_not_release : {code, date_expire, date_validity, id_branch, id_payment_card, id_payment_card_release_detail, name_payment_card, name_payment_card_release, points, value} (lấy nguyên payment_card_code_not_release đã có sẳn)
  * @return  Promise object => obj = {vcode, message, data(payment_card_code)}
  * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
  */
    exchangePaymentCardCode_byEarningPoints(payment_card_code_not_release: any): Promise<unknown>;
    /**
    * hàm này để chọn 1 mã payment_card_code thuộc chương trình bán hàng đưa vào giỏ hàng, sau đó khách sẽ tiến hành đặt mua
    * hàm này đã tạo mới mã payment_card_code với status_6 (trường hợp này ko tồn tại status_1)
    * @example:
    * this.vhCafeWebAPPEndUser.createPaymentCardCode_6(payment_card_code_not_release)
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let payment_card_code = response.data;
            }
          },error=>{
              console.log('error', error)
          })
    * @param payment_card_code_not_release : {code, date_expire, date_validity, id_branch, id_payment_card, id_payment_card_release_detail, name_payment_card, name_payment_card_release, points, value} (lấy nguyên payment_card_code_not_release đã có sẳn ở hàm getPaymentCardCodes_Not_Release())
    * @return  Promise object => obj = {vcode, message, data(payment_card_code)}
    * @notice : hàm này chỉ chạy sau khi khách hàng đã đăng nhập
    */
    createPaymentCardCode_6(payment_card_code_not_release: any): Promise<unknown>;
    /**
    * Hàm này bỏ chọn 1 mã payment_card_code mà khách đã chọn để mua trước đó (status_6)
    * @example:
    * this.vhCafeWebAPPEndUser.deletePaymentCardCode_6('5fb67fda87c0f21d484cbdf3')
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
          }
        },error=>{
            console.log('error', error)
        })
    * @param id_payment_card_code
    * @return Promise => response.data = undefined / error
    */
    deletePaymentCardCode_6(id_payment_card_code: string): Promise<unknown>;
    /**
    * Hàm này chọn 1 payment_card_code có status 2 hoặc 3 chuyển sang status 8 (trạng thái "chọn đổi thẻ lấy hàng hóa")
    * @example:
    * this.vhCafeWebAPPEndUser.changePaymentCardCode_2or3_to8('5fb67fda87c0f21d484cbdf3')
        .then((response:any)=>{
          console.log('response', response);
          if(response.vcode === 0){
              //-----------your code-----------
          }
        },error=>{
            console.log('error', error)
        })
    * @param id_payment_card_code
    * @return Promise => response.data = undefined / error
    */
    changePaymentCardCode_2or3_to8(id_payment_card_code: string): Promise<unknown>;
    /**
    * @example:
    * this.vhCafeWebAPPEndUser.getPaymentCardCodes_byFields({status:{$in:[2,3]}}, {},{},0)
          .then((response:any)=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bills = response.data;
            }
          },error=>{
              console.log('error', error)
          })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @return  Promise object => obj = {vcode, message, data(array)}
    */
    getPaymentCardCodes_byFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    updatePaymentCardCode(id_payment_card_code: string, value: object): Promise<unknown>;
    /**
      * @example://xem các trường trong ví dụ này thiếu nói anh huy bổ sung
        let data = {
          id_branch: 'sdfaoeuow984439v4n949',
          id_customer: 'gu86gd3th6pfgw54adthji7',
          date: new Date(),
          bill_type:35,     //bill tạm được enduser tạo từ kênh online qua Web, APP
          payment: 990.000,
          tax: 0,
          total: 990.000
        }
        this.vhCafeWebAPPEndUser.createBill(data)
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let bill = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
        bill = {
              _id,              //hệ thống tự thêm vào
              bill_code,        //hệ thống tự thêm vào
  
              id_branch,
              id_customer,
              date,
              bill_type,
              payment,
              tax,
              total
        }
      * @param data : object
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    private createBill;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.updatePayment('5fb6780ca2148e09806c5b01', {total:990000})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param id_bill
      * @param value : object
      * @return  Promise object => response = {vcode, message)}
      */
    updateBill(id_bill: string, value: object): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.deleteBill('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
      * @param id_bill
      * @return Promise => response.data = undefined / error
      */
    deleteBill(id_bill: any): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getBillsByFields({name:{$eq:'name abc'}}, {},{},0)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let bills = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @return  Promise object => obj = {vcode, message, data(array)}
    */
    getBillsByFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getBill('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill = response.data;
            }
          },error=>{
              console.log('error', error)
          })
      *  @param id_bill
      *  @return Promise => payment ={vcode, message, data(object or null)} / error
      */
    getBill(id_bill: any): Promise<unknown>;
    /**
      * Hàm này dùng khi khách hàng đưa sản phảm vào giỏ hàng (bill_type = 35)
      * @example:
      let data = {
        id_branch: '5gt436urbdfsky6',
        id_customer: 'gu86gd3th6pfgw54',
        tax: 0,
        price: 99000,
        quantity: 1,
      }
      this.vhCafeWebAPPEndUser.createBill_Detail_35(data)
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_detail = response.data;
            }
          },error=>{
              console.log('error', error)
          })
      bill_detail = {
          _id,                //hệ thống tự thêm vào
          date: new Date(),   //hệ thống tự thêm vào
          bill_type: 35,      //hệ thống tự thêm vào, bill tạm được enduser tạo từ kênh online qua Web, APP
  
          id_branch,
          id_customer,
          tax,
          price,
          quantity
      }
      * @param data : object
      * @return  Promise object => obj = {vcode, message, data(object)}
      * Luu ý: chỉ có 2 trường hợp, hoặc là thêm thành công, hoặc là báo lỗi error
      */
    createBill_Detail_35(data: any): Promise<unknown>;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt hàng (bill_type = 36)
      * Lưu ý: trường webapp_payment_payment_chose true/false của sản phẩm, quy định sản phẩm được chọn hoặc chưa chọn để thanh toán
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        tax: 0,
        fee: 0,
        total: 10000000,
      }
      let bill_details =[{
        id_product: 'pro006',
        price: 10000000,
        quantity: 1
      },{
        id_product: 'pro007',
        price: 12000000,
        quantity: 1
      }]
      this.vhCafeWebAPPEndUser.createBill_Billdetail_36(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
      * @param bill
      * @param bill_details
      * @return Promise => object = {} or null
      */
    createBill_Billdetail_36(bill: any, bill_details: any): any;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt mua voucher (bill_type = 42)
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        date: new Date(),
        tax: 0,
        fee: 0,
        total: 200000,
      }
      let bill_details =[{
        id_voucher: "pEvqDLsBEFaAROUbyqZV",
        id_voucher_code: "njoaSkUIxkGVxBUyHN10",
        price: 200000,
        quantity: 1,
        ratio: 1,
        vtype: 1,
        products:[{
          id_product: "xmVt5uDH8jaajYJ1KmVo",
          price: 0, //vì bán voucher nên giá sản phẩm luôn luôn là 0
          ptype: 1,
          quantity: 2,
          ratio: 1
        },{
          id_product: "PGtdEroQNKSJjhj1okPs",
          price: 0,
          ptype: 1,
          quantity: 2,
          ratio: 1
        }]
      this.vhCafeWebAPPEndUser.createBill_Billdetail_42(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
      * @param bill
      * @param bill_details
      * @return Promise => object = {} or null
      */
    createBill_Billdetail_42(bill: any, bill_details: any): any;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt đổi voucher lấy sản phẩm (bill_type = 43)
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        date: new Date(),
        tax: 0,
        fee: 0,
        total: 0,
      }
      let bill_details =[{
        id_voucher: "pEvqDLsBEFaAROUbyqZV",
        id_voucher_code: "njoaSkUIxkGVxBUyHN10",
        vtype: 1,
        products:[{
          id_product: "xmVt5uDH8jaajYJ1KmVo",
          price: 0, //vì đổi voucher lấy hàng, nên price luôn luôn là 0
          ptype: 1,
          quantity: 2,
          ratio: 1
        },{
          id_product: "PGtdEroQNKSJjhj1okPs",
          price: 0,
          ptype: 1,
          quantity: 2,
          ratio: 1
        }]
      this.vhCafeWebAPPEndUser.createBill_Billdetail_42(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
      * @param bill
      * @param bill_details
      * @return Promise => object = {} or null
      */
    createBill_Billdetail_43(bill: any, bill_details: any): any;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt mua payment_card (bill_type = 52)
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        date: new Date(),
        tax: 0,
        fee: 0,
        total: 0,
      }
      let bill_details =[{
        id_payment_cardr: "pEvqDLsBEFaAROUbyqZV",
        id_payment_card_code: "njoaSkUIxkGVxBUyHN10",
        price: 500000,
        quantity: 1,
        ratio: 1,
        pctype: 1,
        products:[{
          id_product: "xmVt5uDH8jaajYJ1KmVo",
          price: 0, //vì bán thẻ nên giá sản phẩm luôn luôn là 0
          ptype: 1,
          quantity: 2,
          ratio: 1
        },{
          id_product: "PGtdEroQNKSJjhj1okPs",
          price: 0,
          ptype: 1,
          quantity: 2,
          ratio: 1
        }]
      this.vhCafeWebAPPEndUser.createBill_Billdetail_42(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
      * @param bill
      * @param bill_details
      * @return Promise => object = {} or null
      */
    createBill_Billdetail_52(bill: any, bill_details: any): any;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt đổi payment_card_code lấy sản phẩm (bill_type = 53)
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        date: new Date(),
        tax: 0,
        fee: 0,
        total: 200000,
      }
      let bill_details =[{
        id_payment_card: "pEvqDLsBEFaAROUbyqZV",
        id_payment_card_code: "njoaSkUIxkGVxBUyHN10",
        pctype: 1,
        products:[{
          id_product: "xmVt5uDH8jaajYJ1KmVo",
          price: 0, //vì đổi thẻ lấy hàng, nên giá sản phẩm luôn luôn là 0
          ptype: 1,
          quantity: 1, //đây là số lượng đổi trong hóa đơn đổi lấy hàng này
          outquantity: xem cách tính bên dưới,
          restquantity: xem cách tính bên dưới,
          ratio: 1
        },{
          id_product: "PGtdEroQNKSJjhj1okPs",
          price: 0, //vì đổi thẻ lấy hàng, nên giá sản phẩm luôn luôn là 0
          ptype: 1,
          quantity: 1, //đây là số lượng đổi trong hóa đơn đổi lấy hàng này
          outquantity: xem cách tính bên dưới,
          restquantity: xem cách tính bên dưới,
          ratio: 1
        }]
      this.vhCafeWebAPPEndUser.createBill_Billdetail_52(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
      * @param bill
      * @param bill_details
      * @return Promise => object = {} or null
      * @notice :
      * outquantity (của bill_detail) = outquantity (của thẻ) + quantity (của bill_detail);
      * restquantity (của bill_detail) = quantity (của thẻ) - outquantity (của bill_detail);
      */
    createBill_Billdetail_53(bill: any, bill_details: any): any;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.updateBill_detail('5fb6780ca2148e09806c5b01', {total:990000})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param id_bill
      * @param value : object
      * @return  Promise object => obj = {vcode, message)}
      */
    updateBill_detail(id_bill: string, value: any): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getBill_details('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_details = response.data;
            }
          },error=>{
              console.log('error', error)
          })
      *  @param id_bill
      *  @return  Promise object => obj = {vcode, message, data(array)} / error
      */
    private getBill_details;
    /**
    * @example
    this.vhCafeWebAPPEndUser.getBill_details_byId_bill('RcECbNgU9BdYQo37s30p')
        .then((bill_details)=>{
          console.log('getBill_details_byId_bill', bill_details);
        },(error:any)=>{
          console.log('error ', error);
        })
    * @param id_bill
    * @return Promise => array / orror
    */
    getBill_details_byId_bill(id_bill: any): any;
    /**
    * @example:
    * this.vhCafeWebAPPEndUser.getBill_detailsByFields({id_bill:{$eq:'38q90h9ehf9wyn4sjkdfa'}},{},{},0)
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_details = response.data;
            }
          },error=>{
              console.log('error', error)
          })
  * @param query
  * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
  * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
  * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
  * @return  Promise object => obj = {vcode, message, data(array)}
  */
    getBill_detailsByFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.getBill_detail('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_detail = response.data;
            }
          },error=>{
              console.log('error', error)
          })
      *  @param id_bill_detail
      *  @return Promise => response ={vcode, message, data(object or null)} / error
      */
    getBill_detail(id_bill_detail: any): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPEndUser.deleteBill_Detail('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
      * @param id_bill_detail
      * @return Promise => response.data = undefined / error
      */
    deleteBill_Detail(id_bill_detail: string): Promise<unknown>;
    /**
    * Lưu ý: xóa tất cả các bill_type(từ 1 đến 28, 40, 41, 50, 51) đều dùng hàm này, chưa có xóa bill_type 30 và 31
    * @example
    this.vhCafeWebAPPEndUser.deleteBill_Billdetail('RcECbNgU9BdYQo37s30p')
        .then((bool)=>{
          if(bool){
            console.log('success');
          }else{
            console.log('no success');
          }
        },(error:any)=>{
          console.log('error ', error);
        })
    * @param id_bill
    * @return Promise => null or orror
    */
    deleteBill_Billdetail(id_bill: any): any;
    private changeBillDetails_withPromotions_toRaw;
    private changeBillDetails_withRaw_toPromotions;
    /**
* hàm này trả về voucher code đã phát hành theo trường _id của voucher code.
* trả về có cả code, name_voucher, name_voucher_release
* @example:
*
* this.vhCafeWebAPPEndUser.getVoucher_Code_Name_Release('OUHEDW0512'})
      .then((res)=>{
        console.log('getVoucher_Code_Name_Release', res);
      }, error=>{
        console.log('error', error);
      })
* @param id_voucher_code: cũng chính là code
* @return Promise => obj ={} or null
*/
    getVoucher_Code_Name_Release(id_voucher_code: any): Promise<unknown>;
    /**
    * @example:
    * this.vhCafeWebAPPEndUser.changeBillDetails_withNameUnitsLots(bill_details)
          .then((res)=>{
            console.log('changeBillDetails_withNameUnitsLots', res);
            let _bill_details = res;
          }, error=>{
            console.log('error', error);
          })
    * @param bill_details
    * @return  Promise => array = [{},{},...]
    * Luu ý: chỉ có 2 trường hợp, hoặc là thêm thành công, hoặc là báo lỗi error
    */
    private changeBillDetails_withNameUnitsLots;
    /**
    * hàm này trả về payment_card code đã phát hành theo trường _id của payment_card code
    * trả về có cả code, name_payment_card, name_payment_card_release
    * @example:
    *
    * this.vhCafeWebAPPEndUser.getPaymentCard_Code_Name_Release('OUHEDW0512'})
          .then((res)=>{
            console.log('getPaymentCard_Code_Name_Release', res);
          }, error=>{
            console.log('error', error);
          })
    * @param id_payment_card_code: cũng chính là code
    * @return Promise => obj ={} or null
    */
    getPaymentCard_Code_Name_Release(id_payment_card_code: any): Promise<unknown>;
    /**
    * @example:
    * this.vhCafeWebAPPEndUser.getBillDetails_withName({name:'promition 1'})
          .then((bill_details)=>{
            console.log('getBillDetails_withName', bill_details);
          },error=>{
            console.log('error', error);
          })
    * @param bill_details
    * @return  Promise => array = [{},{},...]
    * Luu ý: chỉ có 2 trường hợp, hoặc là thêm thành công, hoặc là báo lỗi error
    */
    private changeBillDetails_withPromotionNameUnitsLots;
    /**
    * @example:
    * this.vhCafeWebAPPEndUser.getDoc_fromDatabase('products', '5fb67fda87c0f21d484cbdf3')
        .then((product)=>{
          console.log('getDoc_fromDatabase', product);
        },error=>{
          console.log('error', error);
        })
    * @param colname
    * @param _id
    * @return Promise => obj ={} or null
    */
    private getDoc_fromDatabase;
}
export declare class VhCafeWebAPPAdmin {
    private vhAlgorithm;
    private camera;
    private imagePicker;
    private webview;
    private imgserverURL;
    private webappserverURL;
    private project;
    private dbstorage;
    private database;
    private store;
    private user;
    private branchs;
    constructor(vhAlgorithm: VhAlgorithm, camera: Camera, imagePicker: ImagePicker, webview: WebView);
    /**
     * @example:
     * this.vhCafeWebAPPAdmin.initializeProject('vhcafe','firebase','research','research', 394637, '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2')
          .then(()=>{
            //-----------your code----------
          })
     * @param project
     * @param dbstorage
     * @param dbserverversion
     * @param camserverversion
     * @param fwcode
     * @param database : một database nào đó '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2'
     * @returns
     */
    initializeProject(project: string, dbstorage: string, dbserverversion: string, camserverversion: string, fwcode: number, database: string): Promise<any>;
    /**
     * @example
     * this.vhCafeWebAPPAdmin.searchList('products',["name", "describe"], 'Điện Thoại')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let array_searched_data = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param array_field
      * @param value
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    searchList(colname: string, array_field: any, value: string, limit: number, page: number): Promise<unknown>;
    /**
     * @example:Lấy hình ảnh từ Camera thiết bị
     *  this.vhCafeWebAPPAdmin.getThumbnailFromCamera(128, 128, "employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
     * @param w
     * @param h
     * @param folder
     * @param oldthumbnailURL
     * @returns
     */
    getThumbnailFromCamera(w: any, h: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Camera thiết bị
     *  this.vhCafeWebAPPAdmin.getImageFromCamera("employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
     * @param folder
     * @param oldthumbnailURL
     * @returns
     */
    getImageFromCamera(folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Album thiết bị
     *  this.vhCafeWebAPPAdmin.getThumbnailFromAlbum(128, 128, "employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
     * @param w
     * @param h
     * @param folder
     * @param oldthumbnailURL
     * @returns
     */
    getThumbnailFromAlbum(w: any, h: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Album thiết bị
     *  this.vhSalesWebAPPAdmin.getImageFromAlbum("employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
     * @param folder
     * @param oldthumbnailURL
     * @returns
     */
    getImageFromAlbum(folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
       * @example:Lấy hình ảnh từ Desktop
       * onUpload(e?) {
            const file = e.target.files[0];
            this.vhCafeWebAPPAdmin.getThumbnailFromDesktop(file, 128, 128, "employees", this.img).then(
              photoURL => {
                  this.img = photoURL;
                  this.detailEmployee.controls["img"].setValue(photoURL);
                  this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
                  this.updateEmployee(this.detailEmployee.value);
                }
              },error => {
                this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
              }
            );
      }
       * @param file
       * @param w
       * @param h
       * @param folder: tên của loại component, ví dụ webapp_product, webapp_category, webapp_news....
       * @param oldthumbnailURL : String
       * @returns
       * @notice: trường hợp cập nhật hình ảnh, phải truyền vào hàm tham số oldthumbnailURL để xóa ảnh cũ đi, tránh làm server bị rác
       */
    getThumbnailFromDesktop(file: any, w: any, h: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Desktop đẩy lên server với kích thước hình ko thay đổi
     * onUpload(e?) {
          const file = e.target.files[0];
          this.vhCafeWebAPPAdmin.getImageFromDesktop(file,"employees", this.img)
            .then((rsp:any)=>{
                console.log('rsp', rsp);
                if(rsp.vcode === 0){
                  this.img = rsp.data;
                  this.detailEmployee.controls["img"].setValue(this.img);
                  this.updateEmployee(this.detailEmployee.value);
                }else if(rsp.vcode === 1){
  
                }else if(rsp.vcode === 2){
  
                }else if(rsp.vcode === 3){
  
                }
                this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            },error => {
              this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
            }
          );
    }
     * @param file
     * @param folder: tên của loại component, ví dụ webapp_product, webapp_category, webapp_news....  hoặc sanpham/webapp_product, sanpham/webapp_category
     * @param oldthumbnailURL : String   *
     * @notice : trường hợp cập nhật hình ảnh, phải truyền vào hàm tham số oldthumbnailURL để xóa ảnh cũ đi, tránh làm server bị rác
     * @returns Object => obj = {vcode, message, data, error}
     * vcode === 0 : upload ảnh thành công
     * vcode === 1 : lỗi import file ảnh
     * vcode === 2 : lỗi upload file ảnh
     * vcode === 3 : không thể upload file ảnh lớn hơn 1Mb
     */
    getImageFromDesktop(file: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    private uploadThumbnail;
    /**
     * vhCafeWebAPPAdmin
     * @param imageURI
     * @param type :'image/jpeg'
     * @param w
     * @param h
     * @param filename
     * @param folder
     * @returns
     */
    private uploadImage;
    private encodeThumbnailUri;
    /**
     * vhCafeWebAPPAdmin
     * @param imageUri
     * @param type : 'image/jpeg'
     * @param w
     * @param h
     * @param callback
     */
    private encodeImageUri;
    /**
     *@example
        this.vhCafeWebAPPAdmin.deleteThumbnail([url_img, url_img1])
            .then(()=>{
              //-----------your code here-----------
            },error=>{
                console.log('error', error)
            })
     * @param thumbnailURL : Array
     * @returns Promise => true or false
     */
    deleteThumbnail(thumbnailURL: any): Promise<any>;
    private uploadBase64Image_onFirebase;
    /**
     * example:
     *
     * @param base64image
     * @param filename
     * @param folder
     * @returns
     */
    private uploadBase64Image_onViethas;
    /**
     * @example:
     * this.deleteImage_onFirebase(thumbnailURL[i])
            .then(()=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
     * @param imageURL
     * @returns
     */
    private deleteImage_onFirebase;
    /**
     * @example:
     * this.deleteImage_onViethas(thumbnailURL[i])
            .then(()=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
     * @param imageURL
     * @returns
     */
    private deleteImage_onViethas;
    /**
     * Lấy về danh sách thư mục, file trong thư mục định vị bởi đường dẫn path
     * @example:
       this.vhCafeWebAPPAdmin.getFilenames_onViethas("hinhanh/hinh")
            .then((child_list)=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
      * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
      * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
      */
    getFilenames_onViethas(path: string): Promise<unknown>;
    /**
     * Tạo thư mục mới trong thư mục định vị bởi đường dẫn path
     * @example:
       this.vhCafeWebAPPAdmin.createFolder_onViethas("hinhanh", "hinh")
            .then((child_list)=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
      * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
      * @param folder : tên thư mục
      * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
      */
    createFolder_onViethas(path: string, folder: string): Promise<unknown>;
    /**
   * Xóa thư mục, file (đang có) trong thư mục định vị bởi đường dẫn path
   * @example:
     this.vhCafeWebAPPAdmin.deleteFolder_onViethas("hinhanh", "hinh")
          .then((child_list)=> {
            //your code here...
          },error=>{
            console.log('error', error);
          })
    * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
    * @param folder : tên thư mục
    * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
    */
    deleteFolder_onViethas(path: string, folder: string): Promise<unknown>;
    /**
   * Đổi tên thư mục (đang có) trong thư mục định vị bởi đường dẫn path thành tên khác
   * @example:
     this.vhCafeWebAPPAdmin.renameFolder_onViethas("hinhanh", "hinh")
          .then((child_list)=> {
            //your code here...
          },error=>{
            console.log('error', error);
          })
    * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
    * @param folder : tên thư mục
    * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
    */
    renameFolder_onViethas(path: string, oldfolder: string, newfolder: string): Promise<unknown>;
    /**
     * @example
     * this.vhCafeWebAPPAdmin.addComponentContent('webapp_abouts', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addComponentContent(colname: string, data: object): Promise<unknown>;
    /**
     * Hàm này dùng đối với các component chỉ có 1 record dữ liệu duy nhất như component giới thiếu, componet liên lạc....
     * @example
     * this.vhCafeWebAPPAdmin.setComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param id_componentcontent : lấy theo tên của component
      * @param data : tất cả các trường của doc/recort
      * @return  Promise object => response = {vcode, message}
      */
    setComponentContent(colname: string, id_componentcontent: string, data: object): Promise<unknown>;
    /**
  * @example
  * this.vhCafeWebAPPAdmin.updateComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
           .then(response=>{
             console.log('response', response);
             if(response.vcode === 0){
                 //-----------your code-----------
             }
           },error=>{
               console.log('error', error)
           })
   * @param colname
   * @param id_componentcontent
   * @param value
   * @return  Promise object => response = {vcode, message}
   */
    updateComponentContent(colname: string, id_componentcontent: string, value: object): Promise<unknown>;
    /**
   * @example
   * this.vhCafeWebAPPAdmin.deleteComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message}
    */
    deleteComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
   * @example
   * this.vhCafeWebAPPAdmin.getComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
     * @example:
     * this.vhCafeWebAPPAdmin.getComponentContentsByFields('webapp_abouts', {name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getComponentContentsByFields(colname: string, query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhCafeWebAPPEndUser.getComponentContents('webapp_abouts')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    getComponentContents(colname: string): Promise<unknown>;
    getStore(): any;
    getUser(): any;
    /**
      * @example:
      * this.vhCafeWebAPPAdmin.signin_byEmail('cafef110@gmail.com','h674567')
            .then(response=>{
               console.log('response', response);
               if(response.vcode === 0){
                   //-----------your code-----------
               }else if(response.vcode === 1){
                   //-----------your code 1-----------
               }else if(response.vcode === 2){
                   //-----------your code 2-----------
               }else if(response.vcode === 3){
                   //-----------your code 3-----------
               }
            },error=>{
               console.log('error', error)
            })
      * @param email
      * @param password
      * @return Promise object => response = {vcode, message}
      * vcode == 0: Signed in successfully
      * vcode == 1: Wrong email
      * vcode == 2: Wrong password
      * vcode == 3: Email address does not exist on my system
      */
    signin_byEmail(email: string, password: string): Promise<any>;
    /**
     * @example:
     * this.vhCafeWebAPPAdmin.onAuthStateChanged()
           .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }else{
                //-----------your code-----------
                signin_byEmail lại
              }
           },error=>{
              console.log('error', error)
           })
     * @return Promise object => response = {vcode, message}
     * vcode == 0: Signed in successfully
     */
    onAuthStateChanged(): Promise<any>;
    /**
   * @example
   * this.vhCafeWebAPPAdmin.signoutWebAPP()
   * @returns Void
   */
    signout(): void;
    /**
     * @example
     * this.vhCafeWebAPPAdmin.addProduct({})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addProduct(data: object): Promise<unknown>;
    /**
   * @example
   * this.vhCafeWebAPPAdmin.updateProduct('5fb67fda87c0f21d484cbdf3', {})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_product
    * @param value
    * @return  Promise object => response = {vcode, message}
    */
    updateProduct(id_product: string, value: object): Promise<unknown>;
    /**
     * @example
     * this.vhCafeWebAPPAdmin.deleteProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message}
      */
    deleteProduct(id_product: any): Promise<unknown>;
    /**
      * @example
      * this.vhCafeWebAPPAdmin.getProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getProduct(id_product: any): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPAdmin.getProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
      * @example
      * this.vhCafeWebAPPAdmin.getNewProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    private getNewProduct;
    /**
      * @example:
      * this.vhCafeWebAPPAdmin.getNewProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    private getNewProductsByFields;
    /**
    * @example
    * let id_sub_or_product = id_subproduct?id_subproduct:id_product;
    * this.vhCafeWebAPPAdmin.getDetailProduct(id_sub_or_product)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_sub_or_product
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getDetailProduct(id_sub_or_product: any): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPAdmin.getDetailProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getDetailProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
  * hàm này tạo product và thêm subs vào product (lần đầu)
  * Lưu ý: trong product, subProductArray không có các trường quantity, quantity_branch và subs
  * @example:
  * @case 1: manysize (false)
  * let product = {
      allow_sell: true,
      brand: "OEM",
      id_category: "vTr90aYfhDqSCyuRh4DR",
      img: "image link",
      manysize: false,
      name: "test ko sub 3",
      selling: true,
      type: 1,
      warning_number: 3,
      units:[{
        barcode: "3103",
        price: 3100,
        price2: 3101,
        price_import: 3102,
        ratio: 1,
        unit: "Cái"
      }]
  * }
  * @case 2: manysize (true)
  * let product = {
      allow_sell: true,
      brand: "OEM",
      id_category: "vTr90aYfhDqSCyuRh4DR",
      img: "image link",
      manysize: true,
      name: "test sub 4",
      selling: true,
      type: 1,
      warning_number: 3,
      units:[{
        ratio: 1,
        unit: "Cái"
      },{
        barcode: "4203",
        price: 4200,
        price2: 4101,
        price_import: 4202,
        ratio: 10,
        unit: "Hộp"
      }]
    }
    let subProductArray = [{
      barcode: "43004",
      name: "Lớn",
      price: 43000,
      price2: 43002,
      price_import: 43001,
      warning_number: 43003
    }]
  * this.vhCafeWebAPPAdmin.addProductAndSubsProduct(product,subProductArray)
      .then(response=>{
        console.log('response', response);
        if(response.vcode === 0){
            //-----------your code-----------
        }
      },error=>{
          console.log('error', error)
      })
  * @param product
  * @param subProductArray
  * @return  Promise object => response = {vcode, message}
  * Luu ý: chỉ có 2 trường hợp, hoặc là thêm thành công trả về null (resolve), hoặc là thất bại trả về error (reject)
  */
    addProductAndSubsProduct_Cafe(product: any, subProductArray: any): Promise<unknown>;
    private addProductAndSubsProduct_old;
    /**
      * Hàm này cập nhật lại những thay đổi trong sub (cỡ) của sản phẩm
      * @example:
      * this.vhCafeWebAPPAdmin.updateSubProduct('5fb6780ca2148e09806c5b01', {quantity:400})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param id_subproduct
      * @param data
      * @return  Promise object => response = {vcode, message}
      */
    updateSubProduct(id_subproduct: string, value: any): Promise<unknown>;
    /**
      * Hàm này thêm Sub vào Product
      * @example:
      *  let subProduct ={
          allow_sell: true,
          manylot: true,
          name: "Lớn",
          selling: true,
          type: 1,
          warning_number: 5,
          units:[{
            barcode: "384807544448",
            default: true,
            price: 70000,
            price2: 60000,
            price_import: 50000,
            ratio: 1,
            unit: "Cái"
          }],
          days_exp_warning: 30,
          days_import_warning: 60,
          lots:[{
            _id: "tgwOaMDVmQaHfaL8FD02SMl9"
            barcode: "337953449785"
            date_exp: 'October 7, 2022 at 11:59:59 PM UTC+7'
            date_mfg: 'March 1, 2022 at 12:00:00 AM UTC+7'
            hidden: false
            lot_number: "lo1101"
          }]
        }
        this.vhCafeWebAPPAdmin.addSubProduct('5fb6780ca2148e09806c5b01',{price:0, name:'small'})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param id_product
      * @param subProduct
      *@return  Promise object => response = {vcode, message, data(object)}
      */
    addSubProduct(id_product: string, subProduct: any): Promise<unknown>;
    /**
      * Hàm này xóa sản phẩm con trong sản phẩm cha
      * @example:
      * this.vhCafeWebAPPAdmin.deleteSubProduct('5fb67fda87c0f21d484cbdf3')
            .then((rsp)=>{
              if(rsp.vcode === 0){
                  //-----------your code 0-----------
              }else if(rsp.vcode === 1){
                  //-----------your code 1-----------
              }else if(rsp.vcode === 2){
                  //-----------your code 2-----------
              }
          }, error=>{
            reject(error)
          })
      * @param id_subproduct
      * @return Observable object => rsp = {vcode, message}
      * vcode == 0: xóa thành công
      * vcode == 1: Bạn không thể xóa, vì sản phẩm con này đang liên kết với sản phẩm combo khác
      * vcode == 2: Bạn không thể xóa, vì sản phẩm con này đã phát sinh hóa đơn
      */
    deleteSubProduct(id_subproduct: string): Promise<unknown>;
    /**
      * @example
      * this.vhCafeWebAPPAdmin.addCategory({})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let category = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addCategory(data: object): Promise<unknown>;
    /**
    * @example
    * this.vhCafeWebAPPAdmin.updateCategory('5fb67fda87c0f21d484cbdf3', {})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_category
    * @param value
    * @return  Promise object => response = {vcode, message}
    */
    updateCategory(id_category: any, value: any): Promise<unknown>;
    /**
      * @example
      * this.vhCafeWebAPPAdmin.deleteCategory('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_category
      * @return  Promise object => response = {vcode, message}
      */
    deleteCategory(id_category: any): Promise<unknown>;
    /**
      * @example
      * this.vhCafeWebAPPAdmin.getCategory('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let category = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_category
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getCategory(id_category: any): Promise<unknown>;
    /**
      * @example:
      * this.vhCafeWebAPPAdmin.getCategorysByFields({name:{$eq:'name abc'}}, {},{},6, 1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let categorys = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getCategorysByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
      * @example
      * this.vhCafeWebAPPAdmin.getBranch('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.data.vcode === 0){
                    //-----------your code-----------
                    let branch = response.data.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_branch
      * @return  Promise object => obj = {vcode, message, data(object)}
      */
    private getBranch;
    /**
      * @example
      * this.vhCafeWebAPPAdmin.getBranchs()
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let branchs = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    private getBranchs;
    /**
      * @example:
      * let branch = this.vhCafeWebAPPAdmin.getlocalBranch('5fb6780ca2148e09806c5b01');
      * @param id_branch
      * @return Object => obj = {} or null
      */
    getlocalBranch(id_branch: any): any;
    /**
      * @example:
      * let branchs = this.vhCafeWebAPPAdmin.getlocalBranchs();
      * @return Array(object) => array = [{},{},...]
      */
    getlocalBranchs(): any[];
    /**
      * Sau khi đăng nhập vào giao diện quản trị (admin) khởi động xong và vào trang chính xong thì dùng hàm getDefaultBranch() lấy chi nhánh mặc định về (lưu ở local),
      * sẽ có 2 trường hợp xảy ra:
      * + Trường hợp lấy về khác null thì kiểm tra chi nhánh này có tồn tại ở database không (dùng hàm getlocalBranch()). Nếu tồn tại thì
      * không có vấn đề gì xảy ra. Nếu không tồn tại thì hiển thị popup có các chi nhánh lên để khách chọn và lưu vô local
      * (dùng hàm setDefaultBranch()), lưu ý nếu có 1 chi nhánh thôi thì setDefaultBranch luôn, khỏi phải hiện popup ra làm chi
      * + Trường họp lấy về bằng null hiển thị popup có các chi nhánh lên để khách chọn và lưu vô local (dùng hàm setDefaultBranch()),
      * lưu ý nếu có 1 chi nhánh thôi thì setDefaultBranch luôn, khỏi phải hiện popup ra làm chi
      * @example:
      * this.vhCafeWebAPPAdmin.setDefaultBranch('Stbaw79rRVVIm2US55kh');
      * @param branch : lấy branch này y chang từ getlocalBranchs() và truyền vào hàm
      * @returns void
      */
    setDefaultBranch(id_branch: object): void;
    /**
      * @example:
      * this.vhCafeWebAPPAdmin.getDefaultBranch();
      * @returns object or null
      */
    getDefaultBranch(): any;
    /**
      * @example:
      * this.vhCafeWebAPPAdmin.getDefaultBranch();
      * @returns void
      */
    clearDefaultBranch(): void;
}
export declare class VhViethasWebAPPEndUser {
    private vhAlgorithm;
    private webappserverURL;
    private project;
    private dbstorage;
    private database;
    private store;
    private user;
    private singedin;
    constructor(vhAlgorithm: VhAlgorithm);
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.initializeProject('vhsales','firebase','research','research', 394637, '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2')
          .then(()=>{
            //-----------your code----------
          })
     * @param project
     * @param dbstorage
     * @param dbserverversion
     * @param camserverversion
     * @param fwcode
     * @param database : một database nào đó '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2'
     * @returns
     */
    initializeProject(project: string, dbstorage: string, dbserverversion: string, camserverversion: string, fwcode: number, database: string): Promise<any>;
    getStore(): any;
    getUser(): any;
    /**
     * @example
     * this.vhViethasWebAPPEndUser.addComponentContent('webapp_abouts', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addComponentContent(colname: string, data: object): Promise<unknown>;
    /**
     * Hàm này dùng đối với các component chỉ có 1 record dữ liệu duy nhất như component giới thiếu, componet liên lạc....
     * @example
     * this.vhViethasWebAPPEndUser.setComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param id_componentcontent : lấy theo tên của component
      * @param data : tất cả các trường của doc/recort
      * @return  Promise object => response = {vcode, message}
      */
    setComponentContent(colname: string, id_componentcontent: string, data: object): Promise<unknown>;
    /**
 * @example
 * this.vhViethasWebAPPEndUser.updateComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
  * @param colname
  * @param id_componentcontent
  * @param value
  * @return  Promise object => response = {vcode, message}
  */
    updateComponentContent(colname: string, id_componentcontent: string, value: object): Promise<unknown>;
    /**
   * @example
   * this.vhViethasWebAPPEndUser.deleteComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message}
    */
    deleteComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
   * @example
   * this.vhViethasWebAPPEndUser.getComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.getComponentContentsByFields('webapp_abouts', {name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getComponentContentsByFields(colname: string, query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPEndUser.getComponentContents('webapp_abouts')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    getComponentContents(colname: string): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPEndUser.searchList('webapp_products',["name", "describe"], 'Điện Thoại', 20, 1)
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let array_searched_data = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param array_field
      * @param value
      * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
      * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
      * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
      */
    searchList(colname: string, array_field: any, value: string, limit: number, page: number): Promise<unknown>;
    /**
       * @example:
       * this.vhViethasWebAPPEndUser.forgotPassword_byEmail('salesf110@gmail.com','h674567')
             .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code 0-----------
                    let user = response.data;
                }else if(response.vcode === 1){
                    //-----------your code 1-----------
                }
             },error=>{
                console.log('error', error)
             })
       * @param email
       * @param password
       * @return Promise object => response = {vcode, message}
       * vcode == 0: Message sent to email address successfully
       * vcode == 1: Email address does not exist
       */
    forgotPassword_byEmail(email: string, password: string): Promise<any>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.changePassword_byEmail('salesf110@gmail.com','h674567', 'V12345678')
           .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code 0-----------
                  let user = response.data;
              }else if(response.vcode === 1){
                  //-----------your code 1-----------
              }else if(response.vcode === 2){
                  //-----------your code 2-----------
              }else if(response.vcode === 3){
                  //-----------your code 3-----------
              }
           },error=>{
              console.log('error', error)
           })
     * @param email
     * @param oldpassword
     * @param newpassword
     * @return Promise object => response = {vcode, message}
     * vcode == 0: Message sent to email address successfully
     * vcode == 1: Email address does not exist
     * vcode == 2: wrong oldpassword
     * vcode == 3: please reset your password
     */
    changePassword_byEmail(email: string, oldpassword: string, newpassword: string): Promise<any>;
    /**
       * @example:
       * this.vhViethasWebAPPEndUser.signup_byEmail('salesf110@gmail.com','h674567',{})
             .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code 1-----------
                    let enduser = response.data;
                }else if(response.vcode === 1){
                    //-----------your code 2-----------
                }
             },error=>{
                console.log('error', error)
             })
       * @param email
       * @param password
       * @param info : thông tin của enduser
       * @return Promise object => response = {vcode, message, data}
       * vcode == 0: User account registered successful
       * vcode == 1: User Email already exists
       * @notice : sau khi đăng ký thành công, người dùng phải vào email xác nhận xác nhận việc đăng ký này
       */
    signup_byEmail(email: string, password: string, info: object): Promise<any>;
    /**
       * @example:
       * this.vhViethasWebAPPEndUser.signin_byEmail('salesf110@gmail.com','h674567')
             .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code 0-----------
                    let user = response.data;
                }else if(response.vcode === 1){
                    //-----------your code 1-----------
                }else if(response.vcode === 2){
                    //-----------your code 2-----------
                }else if(response.vcode === 3){
                    //-----------your code 3-----------
                }else if(response.vcode === 4){
                    //-----------your code 4-----------
                }
             },error=>{
                console.log('error', error)
             })
       * @param email
       * @param password
       * @return Promise object => response = {vcode, message, data}
       * vcode == 0: Signed in successfully
       * vcode == 1: Wrong email
       * vcode == 2: Please login into your email to confirm your account on my website or APP
       * vcode == 3: Please reset your password
       * vcode == 4: Wrong password
       */
    signin_byEmail(email: string, password: string): Promise<any>;
    /**
     * Hàm này cập nhật thông tin người dùng webapp (người dùng đã nhập vào webapp mới cập  nhật được)
     * @example:
     * this.vhViethasWebAPPEndUser.updateUser('5fb6780ca2148e09806c5b01', {name:'Nguyễn Văn A'})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param value : object
      * @return  Promise object => response = {vcode, message)}
      */
    updateUser(value: object): Promise<unknown>;
    /**
   * @example:
   * this.vhViethasWebAPPEndUser.onAuthStateChanged()
         .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code 0-----------
                let user = response.data;
            }else if(response.vcode === 1){
                //-----------your code 1-----------
            }else if(response.vcode === 2){
                //-----------your code 2-----------
            }else if(response.vcode === 3){
                //-----------your code 3-----------
            }else if(response.vcode === 4){
                //-----------your code 4-----------
            }
         },error=>{
            console.log('error', error)
         })
   * @return Promise object => response = {vcode, message}
   * vcode == 0: Signed in successfully
   * vcode == 1: wrong access_token->email
   * vcode == 2: wrong access_token->password
   * vcode == 3: Please login into your email to confirm your account on my website or APP
   * vcode == 4: Please reset your password
   */
    onAuthStateChanged(): Promise<any>;
    /**
    * @example
    * this.vhViethasWebAPPEndUser.signout();
    * @return void
    */
    signout(): void;
    /**
     * @example
     * let bool = this.vhViethasWebAPPEndUser.checkSignin();
     * @return Boolean => true or false
     */
    checkSignin(): any;
    /**
     * @example
     * this.vhViethasWebAPPEndUser.getProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getProduct(id_product: any): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.getProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPEndUser.getCategory('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let category = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_category
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getCategory(id_category: any): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.getCategorysByFields({name:{$eq:'name abc'}}, {},{},6, 1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let categorys = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getCategorysByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPEndUser.getBranch('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.data.vcode === 0){
                    //-----------your code-----------
                    let branch = response.data.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_branch
      * @return  Promise object => obj = {vcode, message, data(object)}
      */
    getBranch(id_branch: any): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPEndUser.getBranchs(')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let branchs = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    getBranchs(): Promise<unknown>;
    /**
     * @example://xem các trường trong ví dụ này thiếu nói anh huy bổ sung
        let data = {
          id_branch: 'sdfaoeuow984439v4n949',
          id_customer: 'gu86gd3th6pfgw54adthji7',
          date: new Date(),
          bill_type:35,     //bill tạm được enduser tạo từ kênh online qua Web, APP
          payment: 990.000,
          tax: 0,
          total: 990.000
        }
        this.vhViethasWebAPPEndUser.createBill(data)
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let bill = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
        bill = {
              _id,              //hệ thống tự thêm vào
              bill_code,        //hệ thống tự thêm vào
  
              id_branch,
              id_customer,
              date,
              bill_type,
              payment,
              tax,
              total
        }
      * @param data : object
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    private createBill;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.updatePayment('5fb6780ca2148e09806c5b01', {total:990000})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param id_bill
      * @param value : object
      * @return  Promise object => response = {vcode, message)}
      */
    updateBill(id_bill: string, value: object): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.deleteBill('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
      * @param id_bill
      * @return Promise => response.data = undefined / error
      */
    deleteBill(id_bill: any): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.getBillsByFields({name:{$eq:'name abc'}}, {},{},0)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let bills = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @return  Promise object => obj = {vcode, message, data(array)}
    */
    getBillsByFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.getBill('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill = response.data;
            }
          },error=>{
              console.log('error', error)
          })
     *  @param id_bill
     *  @return Promise => payment ={vcode, message, data(object or null)} / error
     */
    getBill(id_bill: any): Promise<unknown>;
    /**
      * Hàm này dùng khi khách hàng quyết định đặt hàng (bill_type = 36)
      * Lưu ý: trường webapp_payment_payment_chose true/false của sản phẩm, quy định sản phẩm được chọn hoặc chưa chọn để thanh toán
      * @example
      let bill ={
        id_customer: 'cus001',
        id_branch: 'jkf983u8f3h8fj38',
        tax: 0,
        fee: 0,
        total: 10000000,
      }
      let bill_details =[{
        id_product: 'pro006',
        price: 10000000,
        quantity: 1
      },{
        id_product: 'pro007',
        price: 12000000,
        quantity: 1
      }]
      this.vhViethasWebAPPEndUser.createBill_Billdetail_36(bill, bill_details)
          .then((bill:any)=>{
            console.log(bill._id);
          },(error:any)=>{
            console.log('error ', error);
          })
     * @param bill
     * @param bill_details
     * @return Promise => object = {} or null
     */
    createBill_Billdetail_36(bill: any, bill_details: any): any;
    /**
     * Hàm này dùng khi khách hàng đưa sản phảm vào giỏ hàng (bill_type = 35)
     * @example:
      let data = {
        id_branch: '5gt436urbdfsky6',
        id_customer: 'gu86gd3th6pfgw54',
        tax: 0,
        price: 99000,
        quantity: 1,
      }
      this.vhViethasWebAPPEndUser.createBill_Detail_35(data)
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_detail = response.data;
            }
          },error=>{
              console.log('error', error)
          })
      bill_detail = {
          _id,                //hệ thống tự thêm vào
          date: new Date(),   //hệ thống tự thêm vào
          bill_type: 35,      //hệ thống tự thêm vào, bill tạm được enduser tạo từ kênh online qua Web, APP

          id_branch,
          id_customer,
          tax,
          price,
          quantity
      }
    * @param data : object
    * @return  Promise object => obj = {vcode, message, data(object)}
    * Luu ý: chỉ có 2 trường hợp, hoặc là thêm thành công, hoặc là báo lỗi error
    */
    createBill_Detail_35(data: any): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.updateBill_detail('5fb6780ca2148e09806c5b01', {total:990000})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
      * @param id_bill
      * @param value : object
      * @return  Promise object => obj = {vcode, message)}
      */
    updateBill_detail(id_bill: string, value: any): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.getBill_details('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_details = response.data;
            }
          },error=>{
              console.log('error', error)
          })
     *  @param id_bill
     *  @return  Promise object => obj = {vcode, message, data(array)} / error
     */
    getBill_details(id_bill: any): Promise<unknown>;
    /**
   * @example:
   * this.vhViethasWebAPPEndUser.getBill_detailsByFields({id_bill:{$eq:'38q90h9ehf9wyn4sjkdfa'}},{},{},0)
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_details = response.data;
            }
          },error=>{
              console.log('error', error)
          })
  * @param query
  * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
  * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
  * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
  * @return  Promise object => obj = {vcode, message, data(array)}
  */
    getBill_detailsByFields(query: object, projection?: object, sort?: object, limit?: number): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.getBill_detail('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
                let bill_detail = response.data;
            }
          },error=>{
              console.log('error', error)
          })
     *  @param id_bill_detail
     *  @return Promise => response ={vcode, message, data(object or null)} / error
     */
    getBill_detail(id_bill_detail: any): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPEndUser.deleteBill_Detail('5fb67fda87c0f21d484cbdf3')
          .then(response=>{
            console.log('response', response);
            if(response.vcode === 0){
                //-----------your code-----------
            }
          },error=>{
              console.log('error', error)
          })
      * @param id_bill_detail
      * @return Promise => response.data = undefined / error
      */
    deleteBill_Detail(id_bill_detail: string): Promise<unknown>;
}
export declare class VhViethasWebAPPAdmin {
    private vhAlgorithm;
    private camera;
    private imagePicker;
    private webview;
    private imgserverURL;
    private webappserverURL;
    private project;
    private dbstorage;
    private database;
    private store;
    private user;
    constructor(vhAlgorithm: VhAlgorithm, camera: Camera, imagePicker: ImagePicker, webview: WebView);
    /**
     * @example:
     * this.vhViethasWebAPPAdmin.initializeProject('vhsales','firebase','research','research', 394637, '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2')
          .then(()=>{
            //-----------your code----------
          })
     * @param project
     * @param dbstorage
     * @param dbserverversion
     * @param camserverversion
     * @param fwcode
     * @param database : một database nào đó '4wk3JMSwSjh4kOLWOMbLbWt0Rdk2'
     * @returns
     */
    initializeProject(project: string, dbstorage: string, dbserverversion: string, camserverversion: string, fwcode: number, database: string): Promise<any>;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.searchList('webapp_products',["name", "describe"], 'Điện Thoại')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let array_searched_data = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param array_field
      * @param value
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    searchList(colname: string, array_field: any, value: string): Promise<unknown>;
    /**
       * @example:Lấy hình ảnh từ Camera thiết bị
       *  this.vhViethasWebAPPAdmin.getThumbnailFromCamera(128, 128, "employees", this.img).then(
            photoURL => {
              this.img = photoURL;
              this.detailEmployee.controls["img"].setValue(photoURL);
              this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
              this.updateEmployee(this.detailEmployee.value);
            },
            () => {
              this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
            }
          );
       * @param w
       * @param h
       * @param folder
       * @param oldthumbnailURL
       * @returns
       */
    getThumbnailFromCamera(w: any, h: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Album thiết bị
     *  this.vhViethasWebAPPAdmin.getImageFromCamera("employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
      *
      * @param folder
      * @param oldthumbnailURL
      * @returns
      */
    getImageFromCamera(folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Album thiết bị
     *  this.vhViethasWebAPPAdmin.getThumbnailFromAlbum(128, 128, "employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
     * @param w
     * @param h
     * @param folder
     * @param oldthumbnailURL
     * @returns
     */
    getThumbnailFromAlbum(w: any, h: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Album thiết bị
     *  this.vhViethasWebAPPAdmin.getImageFromAlbum("employees", this.img).then(
          photoURL => {
            this.img = photoURL;
            this.detailEmployee.controls["img"].setValue(photoURL);
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            this.updateEmployee(this.detailEmployee.value);
          },
          () => {
            this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
          }
        );
     * @param folder
     * @param oldthumbnailURL
     * @returns
     */
    getImageFromAlbum(folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
       * @example:Lấy hình ảnh từ Desktop đưa lên server với kích thước tùy chỉnh ở đầu vào
       * onUpload(e?) {
            const file = e.target.files[0];
            this.vhViethasWebAPPAdmin.getThumbnailFromDesktop(file, 128, 128, "employees", this.img).then(
              photoURL => {
                  this.img = photoURL;
                  this.detailEmployee.controls["img"].setValue(photoURL);
                  this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
                  this.updateEmployee(this.detailEmployee.value);
                }
              },error => {
                this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
              }
            );
      }
       * @param file
       * @param w
       * @param h
       * @param folder: tên của loại component, ví dụ webapp_product, webapp_category, webapp_news.... hoặc sanpham/webapp_product, sanpham/webapp_category
       * @param oldthumbnailURL : String
       * @returns
       * @notice: trường hợp cập nhật hình ảnh, phải truyền vào hàm tham số oldthumbnailURL để xóa ảnh cũ đi, tránh làm server bị rác
       */
    getThumbnailFromDesktop(file: any, w: any, h: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * @example:Lấy hình ảnh từ Desktop đẩy lên server với kích thước hình ko thay đổi
     * onUpload(e?) {
          const file = e.target.files[0];
          this.vhViethasWebAPPAdmin.getImageFromDesktop(file,"employees", this.img)
            .then((rsp:any)=>{
                console.log('rsp', rsp);
                if(rsp.vcode === 0){
                  this.img = rsp.data;
                  this.detailEmployee.controls["img"].setValue(this.img);
                  this.updateEmployee(this.detailEmployee.value);
                }else if(rsp.vcode === 1){
  
                }else if(rsp.vcode === 2){
  
                }else if(rsp.vcode === 3){
  
                }
                this.vhComponent.showToast(2000, (this.languageService.translate("Image was loaded successfully")));
            },error => {
              this.vhComponent.showToast(2000, (this.languageService.translate("Image was failed")));
            }
          );
    }
     * @param file
     * @param folder: tên của loại component, ví dụ webapp_product, webapp_category, webapp_news....  hoặc sanpham/webapp_product, sanpham/webapp_category
     * @param oldthumbnailURL : String   *
     * @notice : trường hợp cập nhật hình ảnh, phải truyền vào hàm tham số oldthumbnailURL để xóa ảnh cũ đi, tránh làm server bị rác
     * @returns Object => obj = {vcode, message, data, error}
     * vcode === 0 : upload ảnh thành công
     * vcode === 1 : lỗi import file ảnh
     * vcode === 2 : lỗi upload file ảnh
     * vcode === 3 : không thể upload file ảnh lớn hơn 1Mb
     */
    getImageFromDesktop(file: any, folder: any, oldthumbnailURL?: any): Promise<any>;
    /**
     * vhViethasWebAPPAdmin
     * @param imageURI
     * @param type
     * @param w
     * @param h
     * @param filename
     * @param folder
     * @returns
     */
    private uploadThumbnail;
    /**
     * vhViethasWebAPPAdmin
     * @param imageURI
     * @param type :'image/jpeg'
     * @param w
     * @param h
     * @param filename
     * @param folder
     * @returns
     */
    private uploadImage;
    /**
     * vhViethasWebAPPAdmin
     * @param imageUri
     * @param type : 'image/jpeg'
     * @param w
     * @param h
     * @param callback
     */
    private encodeThumbnailUri;
    /**
     * vhViethasWebAPPAdmin
     * @param imageUri
     * @param type : 'image/jpeg'
     * @param w
     * @param h
     * @param callback
     */
    private encodeImageUri;
    /**
     *@example
        this.vhViethasWebAPPAdmin.deleteThumbnail([url_img, url_img1])
            .then(()=>{
              //-----------your code here-----------
            },error=>{
                console.log('error', error)
            })
     * @param thumbnailURL : Array
     * @returns Promise => true or false
     */
    deleteThumbnail(thumbnailURL: any): Promise<any>;
    /**
     * vhViethasWebAPPAdmin
     * @param base64image
     * @param filename
     * @param folder
     * @returns
     */
    private uploadBase64Image_onFirebase;
    /**
     * vhViethasWebAPPAdmin
     * example:
     *
     * @param base64image
     * @param filename
     * @param folder
     * @returns
     */
    private uploadBase64Image_onViethas;
    /**
     * @example:
     * this.vhViethasWebAPPAdmin.deleteImage_onFirebase(thumbnailURL[i])
            .then(()=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
     * @param imageURL
     * @returns
     */
    private deleteImage_onFirebase;
    /**
     * Xóa hình ảnh đang lưu trữ trên server, truyền vào đường link của file (href)
     * @example:
     * this.vhViethasWebAPPAdmin.deleteImage_onViethas(thumbnailURL[i])
            .then(()=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
     * @param imageURL
     * @returns undefined
     */
    deleteImage_onViethas(imageURL: string): Promise<unknown>;
    /**
     * Lấy về danh sách thư mục, file trong thư mục định vị bởi đường dẫn path
     * @example:
       this.vhViethasWebAPPAdmin.getFilenames_onViethas("hinhanh/hinh")
            .then((child_list)=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
     * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
     * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
     */
    getFilenames_onViethas(path: string): Promise<unknown>;
    /**
     * Tạo thư mục mới trong thư mục định vị bởi đường dẫn path
     * @example:
       this.vhViethasWebAPPAdmin.createFolder_onViethas("hinhanh", "hinh")
            .then((child_list)=> {
              //your code here...
            },error=>{
              console.log('error', error);
            })
     * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
     * @param folder : tên thư mục
     * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
     */
    createFolder_onViethas(path: string, folder: string): Promise<unknown>;
    /**
   * Xóa thư mục, file (đang có) trong thư mục định vị bởi đường dẫn path
   * @example:
     this.vhViethasWebAPPAdmin.deleteFolder_onViethas("hinhanh", "hinh")
          .then((child_list)=> {
            //your code here...
          },error=>{
            console.log('error', error);
          })
   * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
   * @param folder : tên thư mục
   * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
   */
    deleteFolder_onViethas(path: string, folder: string): Promise<unknown>;
    /**
   * Đổi tên thư mục (đang có) trong thư mục định vị bởi đường dẫn path thành tên khác
   * @example:
     this.vhViethasWebAPPAdmin.renameFolder_onViethas("hinhanh", "hinh")
          .then((child_list)=> {
            //your code here...
          },error=>{
            console.log('error', error);
          })
   * @param path : folder gốc (root) truyền vào "", hoặc dạng folder1/folder2/folder2
   * @param folder : tên thư mục
   * @returns Array => array = [{name, type, path},{name, type, href}]; type = 0 là folder, type !=0 là file
   */
    renameFolder_onViethas(path: string, oldfolder: string, newfolder: string): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.addComponentContent('webapp_abouts', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addComponentContent(colname: string, data: object): Promise<unknown>;
    /**
     * Hàm này dùng đối với các component chỉ có 1 record dữ liệu duy nhất như component giới thiếu, componet liên lạc....
     * @example
     * this.vhViethasWebAPPAdmin.setComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @param id_componentcontent : lấy theo tên của component
      * @param data : tất cả các trường của doc/recort
      * @return  Promise object => response = {vcode, message}
      */
    setComponentContent(colname: string, id_componentcontent: string, data: object): Promise<unknown>;
    /**
  * @example
  * this.vhViethasWebAPPAdmin.updateComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3', {})
           .then(response=>{
             console.log('response', response);
             if(response.vcode === 0){
                 //-----------your code-----------
             }
           },error=>{
               console.log('error', error)
           })
   * @param colname
   * @param id_componentcontent
   * @param value
   * @return  Promise object => response = {vcode, message}
   */
    updateComponentContent(colname: string, id_componentcontent: string, value: object): Promise<unknown>;
    /**
   * @example
   * this.vhViethasWebAPPAdmin.deleteComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then((rsp:any)=>{
              console.log('rsp', rsp);
              if(rsp.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message}
    */
    deleteComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
   * @example
   * this.vhViethasWebAPPAdmin.getComponentContent('webapp_abouts', '5fb67fda87c0f21d484cbdf3')
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let product = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param id_componentcontent
    * @return  Promise object => response = {vcode, message, data(object)}
    */
    getComponentContent(colname: string, id_componentcontent: string): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPAdmin.getComponentContentsByFields('webapp_abouts', {name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param colname
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getComponentContentsByFields(colname: string, query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPEndUser.getComponentContents('webapp_abouts')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let componentcontent = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param colname
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    getComponentContents(colname: string): Promise<unknown>;
    getStore(): any;
    getUser(): any;
    /**
      * @example:
      * this.vhViethasWebAPPAdmin.signin_byEmail('salesf110@gmail.com','h674567')
            .then(response=>{
               console.log('response', response);
               if(response.vcode === 0){
                   //-----------your code-----------
               }else if(response.vcode === 1){
                   //-----------your code 1-----------
               }else if(response.vcode === 2){
                   //-----------your code 2-----------
               }else if(response.vcode === 3){
                   //-----------your code 3-----------
               }
            },error=>{
               console.log('error', error)
            })
      * @param email
      * @param password
      * @return Promise object => response = {vcode, message}
      * vcode == 0: Signed in successfully
      * vcode == 1: Wrong email
      * vcode == 2: Wrong password
      * vcode == 3: Email address does not exist on my system
      */
    signin_byEmail(email: string, password: string): Promise<any>;
    /**
     * @example:
     * this.vhViethasWebAPPAdmin.onAuthStateChanged()
           .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }else{
                //-----------your code-----------
                signin_byEmail lại
              }
           },error=>{
              console.log('error', error)
           })
     * @return Promise object => response = {vcode, message}
     * vcode == 0: Signed in successfully
     */
    onAuthStateChanged(): Promise<any>;
    /**
   * @example
   * this.vhViethasWebAPPAdmin.signoutWebAPP()
   * @returns Void
   */
    signout(): void;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.addProduct({})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addProduct(data: object): Promise<unknown>;
    /**
   * @example
   * this.vhViethasWebAPPAdmin.updateProduct('5fb67fda87c0f21d484cbdf3', {})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_product
    * @param value
    * @return  Promise object => response = {vcode, message}
    */
    updateProduct(id_product: string, value: object): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.deleteProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message}
      */
    deleteProduct(id_product: any): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.getProduct('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let product = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_product
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getProduct(id_product: any): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPAdmin.getProductsByFields({name:{$eq:'name abc'}}, {},{},6,1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let products = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getProductsByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.addCategory({})
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let category = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param data
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    addCategory(data: object): Promise<unknown>;
    /**
   * @example
   * this.vhViethasWebAPPAdmin.updateCategory('5fb67fda87c0f21d484cbdf3', {})
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
              }
            },error=>{
                console.log('error', error)
            })
    * @param id_category
    * @param value
    * @return  Promise object => response = {vcode, message}
    */
    updateCategory(id_category: any, value: any): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.deleteCategory('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_category
      * @return  Promise object => response = {vcode, message}
      */
    deleteCategory(id_category: any): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.getCategory('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let category = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_category
      * @return  Promise object => response = {vcode, message, data(object)}
      */
    getCategory(id_category: any): Promise<unknown>;
    /**
     * @example:
     * this.vhViethasWebAPPAdmin.getCategorysByFields({name:{$eq:'name abc'}}, {},{},6, 1)
            .then(response=>{
              console.log('response', response);
              if(response.vcode === 0){
                  //-----------your code-----------
                  let categorys = response.data;
              }
            },error=>{
                console.log('error', error)
            })
    * @param query
    * @param projection — đang tìm hiểu, tạm thời để giá trị là {}
    * @param sort — null hoặc {}:không sắp xếp; {date:1}: sắp xếp theo ASC; {date:-1}: sắp xếp theo DESC
    * @param limit — null hoặc 0: không giới hạn record get về; 2: get về 2 record
    * @param page — null hoặc 0 hoặc 1: get về trang đầu tiên; 2: get về trang thứ 2
    * @return  Promise object => response = {vcode, message, data(array), limit, page, totalpages}
    */
    getCategorysByFields(query: object, projection?: object, sort?: object, limit?: number, page?: number): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.getBranch('5fb67fda87c0f21d484cbdf3')
              .then(response=>{
                console.log('response', response);
                if(response.data.vcode === 0){
                    //-----------your code-----------
                    let branch = response.data.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @param id_branch
      * @return  Promise object => obj = {vcode, message, data(object)}
      */
    getBranch(id_branch: string): Promise<unknown>;
    /**
     * @example
     * this.vhViethasWebAPPAdmin.getBranchs()
              .then(response=>{
                console.log('response', response);
                if(response.vcode === 0){
                    //-----------your code-----------
                    let branchs = response.data;
                }
              },error=>{
                  console.log('error', error)
              })
      * @return  Promise object => response = {vcode, message, data(array)}
      */
    getBranchs(): Promise<unknown>;
}
export declare class VhAlgorithm {
    private dom;
    constructor(dom: DomSanitizer);
    /**
   * Hàm này lấy về 1 unit của sản phẩm theo ratio truyền vào
   * @example
   * let unit = this.vhAlgorithm.getUnit_byRatio(units, 1, 1);
   * @param units
   * @param ratio
   * @param type
   * type = 1 : unit của sản phẩm
   * type = 2 : unit của dịch vụ
   * type = 3 : unit của combo
   * type = 4 : unit của coupon
   * type = 5 : unit của voucher
   * type = 6 : unit của payment_card
   * @return Object => obj = {} hoặc null
   */
    getUnit_byRatio(units: any, ratio: number, type?: number): any;
    /**
   * Hàm này tạo chuỗi số, ký tự ngẫy nhiên có chiều dài là length
   * @param length: không truyền length vào mặc định chuỗi tạo ra có chiều dài 24
   * @returns
   */
    createObjectID(length?: number): string;
    /**
     * Hàm này tạo chuỗi ký tự (ID) từ bí danh truyền vào (alias)
     * @param alias
     * @param length chiều dài chuỗi ký tự ID được tạo ra; ko truyền vào chiều dãi ID = chiều dài chuỗi alias
     * @returns
     */
    createObjectID_fromAlias(alias: string, length?: number): string;
    /**
   * @example
      let bill_code = this.vhAlgorithm.createBillCode();
      console.log(bill_code);
   * @return String  -----> "3YU0409"
   */
    createBillCode(billdate?: any): any;
    /**
     * @example
        let card_code = this.ordinaryAlgorithm.createCardCode();
        console.log(card_code);
     * @return String  -----> "1KR3YU0409"
     */
    createCardCode(carddate?: any): any;
    /**
  * @example SET:
  * localStorageSET('local_name', {a=1, b='hai'});
  * localStorageSET('local_name', 15000);
  * localStorageSET('local_name', 'muoi lam nghin dong');
  * @returns
  */
    localStorageSET(name: string, value: any): void;
    /**
     * @example GET:
     * let object = localStorageGET('local_name');
     * @returns
     */
    localStorageGET(name: string): any;
    /**
     * @example:
     * 0 -> 0
     * 1 -> 1.0
     * 2 -> 2.00
     * 3 -> 3.000
     * @param money
     */
    vhcurrencyunit(money: any): any;
    vhcurrencyunit_symbol(money: any): any;
    vhpercent(number: any): string;
    /**
     * @example:
     * 123456.78 ->123456.78
     * 123456.78 ->123,456.78
     * 123456.78 ->12,3456.78
     * 123456.78 ->1,23,456.78
     * @param classname
     */
    vhnumeral(classname: any): any;
    vhphoneNumber(classname: any): any;
    vhYoutubeLink(value: any): import("@angular/platform-browser").SafeResourceUrl;
    searchList(value: any, array_list: any, array_field: any): any[];
    changeAlias(alias: any): any;
    sortVietnamesebyASC(array: any, field: any): any;
    sortVietnamesebyDESC(array: any, field: any): any;
    sortDatebyASC(array: any, field: any): any;
    sortDatebyDESC(array: any, field: any): any;
    sortStringbyASC(array: any, field: any): any;
    sortStringbyDESC(array: any, field: any): any;
    sortNumberbyASC(array: any, field: any): any;
    sortNumberbyDESC(array: any, field: any): any;
    /**
   * Số ngày trong tháng của một thời gian
   * @param year
   * @param month
   */
    getNumberOfDaysInMonth(year: number, month: number): 31 | 29 | 28 | 30;
}
